<?
/********************************************************
 *                                                      *
 *          Clases Para la Memoria de Trabajo           *
 *                                                      *
 ********************************************************/
/*  Archivos de java comprendidos en este archivo:
        Memoria.java
        Contexto.java
        CargaMem.java
        ObjetoG.java
        Operador.java
        Relacion.java
        Solucion.java
        Accion.java
        Mapeo.java
*/

/*               Clase Memoria                          */
class Memoria
{
  var $asociaciones=array(); //Asociaciones de contextos con acciones
  var $contextos=array(); //Los contextos en memoria
  var $acciones=array(); //Las acciones en memoria
  var $ctcounter=1; //Contador de contextos
  var $accounter=1; //Contador de acciones
  var $ctindex; //Indice de contextos tomando en cuenta los objetos
	var $resueltos=array(); //problemas resueltos
	var $definiciones=array(); //operadores definidos en la experiencia
  
  function Memoria()
    {
      $this->ctindex=new CTIndex();
    }
  function clase()
    {
      return 'Memoria';
    }
  function asocia($contexto,$accion,$reporta=false)
    {
      //Buscar el contexto entre los existentes (crearlo si no)
      //determinar mapeo de contexto nuevo a contexto existente
      $cMem=$this->buscaCont($contexto,"e",1);
      //Buscar la accin entre las acciones (crearla si no existe)
      //determinar mapeo de accin existente a la accin nueva
      $aMem=$this->buscaAcc($accion);
      //Determinar mapeo de accin nueva a contexto nuevo (identidad?)
      //Debe ser identidad puesto que viene de un problema que se est leyendo
      //Con los 3 mapeos hacer uno de la accin existene a el contexto existente.
      $mapC=$cMem[0]['mapeo'];
      $mapA=$aMem['mapeo'];
      $mapeo=$mapC->post($mapA); //Aqu se hace la composicin de mapeos
      $idCt=$cMem[0]['id'];
      $idAc=$aMem['id'];
      if(isset($this->asociaciones[$idCt]))
	$this->asociaciones[$idCt]->add($idAc,$mapeo);
      else
	$this->asociaciones[$idCt]=new AccAsoc($idAc,$mapeo);
    }

  function getAsoc($contexto,$caso,$match,$Prob) //busca un contexto en memoria y sus acciones asociadas
    {
      $ctmem=$this->buscaCont($contexto,$caso,$match,false);//busca el contexto
      if(count($ctmem))
	{
	  print "Contextos en Memoria\n";
	  //print_r($ctmem);
	}
      $acciones=array();
      foreach($ctmem as $ct) //para cada contexto encontrado
	{
	  $idCt=$ct['id'];
	  $this->contextos[$idCt]->_print(true);
	  print 'Id Contexto: '.$idCt.' Rank: '.$ct['rank'].' Mapeo: '.$ct['mapeo']->_print()."\n";
	  $accs=$this->asociaciones[$idCt]->get(); //traemos las acciones asociadas
	  foreach($accs as $idAc => $infoAcc)
	    {
	      $ctOrig=clone $this->contextos[$idCt];// esto nos da el contexto asociado en memoria
	      //como la busqueda del contexto no necesariamete fue con el contexto que buscamos
	      //debemos encontrar el mapeo adecuado al problema
	      $mapeoCt='';
	      if($Prob)
		{
		  $deNuevo=$ctOrig->comp($Prob,$ct['mapeo']);
		  $mapeoCt=$deNuevo['mapeo'];
		}
	      else
		{
		  $mapeoCt=$ct['mapeo'];
		}
	      print 'Id Contexto: '.$idCt.' Rank: '.$ct['rank'].' Mapeo: '.$mapeoCt->_print()."\n";
				//$ctOrig->_print(true);
	      $ctOrig->applyMap($mapeoCt->reverse()); //no tena el reverse() qu es lo correcto?
				//$ctOrig->_print(true);
	      $mapeo=$infoAcc->get(); //se obtiene el mapeo entre la accin y el contexto encontrado
	      $mapeo=$mapeoCt->reverse()->post($mapeo[0]); //se otiene el mapeo entre la accin y el contexto buscado
	      $accion=clone $this->getAccion($idAc); //OJO: revisar la necesidad de [0] en la linea anterior
	      $accion->applyMap($mapeo);
	      $accion->set_from($ctOrig);
	      //$mapeo->_print(true);
	      $acciones[]=array($accion); //necesitamos saber en que contexto se aplicaba para determinar los prerequisitos de la accin. OJO aqui puede ser ms util una copia del contexto mapeado. Ya est!
	    }
	}
      return $acciones;
    }
	
  function getId($accion)
    { //obtiene el Id de una accin dada
      return array_search($accion,$this->acciones);
    }
  function buscaCont($contexto,$caso,$matching,$inicio=true)
    { //busca un contexto en la memoria
      $resultados=array();
      $CtMem=$this->ctindex->searchCt($contexto,$caso,$matching);
      //if(count($CtMem))
      //{
      //print "  Funcin buscaCont, contextos encontrados:\n";
      //print_r($CtMem);
      //}
      global $Log;
      if(!$inicio)
	$Log->anota("\nBusca:".$contexto->_print()."\n\n mn rank: $matching\n");
      foreach ($CtMem as $CtId)
	{
	  //print "*** Contexto candidato\n";
	  //$this->contextos[$CtId]->_print(true);
	  $matchC=$this->contextos[$CtId]->comp($contexto);//Parece que aqui es donde puedo mejorar la comparacion.
	  $mr=$matchC['rank'];
	  //print "\n  ooo  $CtId: $matching";
	  //print_r($matchC);
	  $Log->anota("\t rank: $mr
\t\tmapeo:".$matchC['mapeo']->_print());
	  $Log->anota("\n\t".$this->contextos[$CtId]->_print()."\n\n");
	  if($mr >= $matching) //Aqui puedo agregar el rank a $m
	    {
	      $m=array();
	      $m['id']=$CtId;
	      $m['mapeo']=$matchC['mapeo'];
	      $m['rank']=$mr;
	      $resultados[]=$m;
	    }
	}
      if(count($resultados) == 0 and $inicio)
	{
	  $CtId=$this->ctcounter++;
	  $this->contextos[$CtId]=$contexto;
	  $this->ctindex->addCt($contexto,$CtId);
	  $resultados[]=array('id'=>$CtId,
			      'mapeo'=>new Mapeo($contexto)); //mapeo identidad
	}
      return $resultados;
    }
  function buscaAcc($accion)
    {
      foreach($this->acciones as $acc)
	{
	  $matchA=$acc->comp($accion,new Mapeo()); //NOTA: esta funcin debe devolver un arreglo
	  if(count($matchA))
	    return $matchA;
	}
      //si llegamos aqui es porque la accin no est en memoria,
      //entonces la creamos.
      $AcId=$this->accounter++;
      $accion->setId($AcId);
      $this->acciones[$AcId]=$accion;
      return array('id' => $AcId,
		   'mapeo' => new Mapeo($accion));
    }
  function getAccion($AcId)
    {
      return $this->acciones[$AcId];
    }
  function _print($imprime=false)
    {
      $texto=" -------   Asociaciones   -------\n\n";
      foreach($this->asociaciones as $idct=>$as)
	$texto.="ID Contexto: $idct\n".$as->_print()."\n";
      $texto.="\n -------    Contextos    -------\n\n";
      foreach($this->contextos as $idct=>$ct)
	$texto.="ID Contexto: $idct\n".$ct->_print()."\n";
      $texto.="\n -------     Acciones     -------\n\n";
      foreach($this->acciones as $idac => $ac)
	$texto.="ID Accin: $idac".$ac->_print()."\n";
      $texto.="\n -------     Operadores Definidos     -------\n\n";
      foreach($this->definiciones as $iddef => $def)
	$texto.="Operacion : $iddef\n";
			
      if($imprime)
	print "$texto\n";
      return $texto;
    }
  /*    Carga una nueva solucin a la experiencia en memoria*/
  function add($contexto,$pasos,$define)
    {
      global $rel2op;
      //$contexto=$problema['contexto'];
      //$define=$problema['define'];
      //creamos el objeto solucion y lo guardamos en el conjunto de problemas resueltos para tener disponible la solucin tal cual, especialmente que si se define un nuevo operador, su problema definitorio se puede usar.
      $solucion=new Solucion(clone $contexto,$pasos);
      $rix=count($this->resueltos);
      $this->resueltos[$rix]=$solucion;
      //Ahora guardamos define en el conjunto de definiciones
      if($define)
	{
	  $define->setIdSol($rix);
	  $this->definiciones[$define->id()]=$define;
	  print "Se define operador ".$define->nop().": ".$define->id()."\n";
	  $rel2op[$define->nop()]=$define->nop();
	}
      $cambiosForzados=new Mapeo();
      foreach($pasos as $paso)
	{
	  $paso->applyMap($cambiosForzados,1);
	  $nombreOrig=$paso->nombre();
	  $cont= clone $contexto; //hacemos una copia del contexto
	  $paso->postcondicion($contexto,true); //actualizamos el contexto
	  $nvoNombre=$paso->nombre();
	  $this->asocia($cont,$paso,$reporta); //asociamos este contexto con la accin
	  //aqui podran ejecutarse simplificadores del contexto actual
	  //$contexto->_print();
	  if($nombreOrig != $nvoNombre)
	    $cambiosForzados->map($nombreOrig,$nvoNombre);
	}
    }
	
  /*    Carga un archivo de experiencia en la memoria    */
  function Load($rutaArchivo,$reporta=false)
    {
      print "Carga Experiencia Previa\n";
      $doc= new domDocument();
      $doc->load($rutaArchivo);
      $root=$doc->documentElement;
      foreach($root->getElementsByTagName('solucion') as $sol) //Para cada problema resuelto
	{
	  $contexto=$this->getContexto($sol->getElementsByTagName('contexto')->item(0)); //extraemos el problema
	  $pasos=$this->getPasos($sol->getElementsByTagName('pasos')->item(0),$contexto); //y los pasos de la solucion
	  $define=$sol->getElementsByTagName('define')->item(0);
	  if($define)
	    $define=$this->getDefine($define);
	  $this->add($contexto,$pasos,$define);
	  /*
	   //creamos el objeto solucion y lo guardamos en el conjunto de problemas resueltos
					$solucion=new Solucion(clone $contexto,$pasos);
					$rix=count($this->resueltos);
					$this->resueltos[$rix]=$solucion;
					//Ahora guardamos define en el conjunto de definiciones
					if($define)
						{
							$define->setIdSol($rix);
							$this->definiciones[$define->id()]=$define;
						}
						//$contexto->_print();
					$cambiosForzados=new Mapeo();
					foreach($pasos as $paso)
						{
							$paso->applyMap($cambiosForzados,1);
							$nombreOrig=$paso->nombre();
							$cont= clone $contexto; //hacemos una copia del contexto
							$paso->postcondicion($contexto,true); //actualizamos el contexto
							$nvoNombre=$paso->nombre();
							$this->asocia($cont,$paso,$reporta); //asociamos este contexto con la accin
							//aqui podran ejecutarse simplificadores del contexto actual
							//$contexto->_print();
							if($nombreOrig != $nvoNombre)
								$cambiosForzados->map($nombreOrig,$nvoNombre);
						}*/
	  //print_r($this->asociaciones);
	  //print"--\n";
	}
      //print_r($this->contextos);
      //print_r($this->acciones);
      //print"---\n";
    }
  function getContexto($contextoX) //extrae el problema
    {
      $cont= new Contexto();
      $this->getObjetos($contextoX->getElementsByTagName('conocidos')->item(0),$cont,'c');
      $this->getObjetos($contextoX->getElementsByTagName('desconocidos')->item(0),$cont,'d');
      $this->getRels($contextoX->getElementsByTagName('satisfechas')->item(0),$cont,'s');
      $this->getRels($contextoX->getElementsByTagName('insatisfechas')->item(0),$cont,'i');
      return $cont;
    }
  function getObjetos($listax,$cont,$tobj) //extrae objetos geomtricos
    {
      foreach($listax->childNodes as $obj)
	if($obj->nodeName != '#text')
	  $this->getObjeto($obj,$cont,$tobj);
      /*Nota de la versin de java:
            Aqui tenemos que resolver una de las situaciones ms importantes.
            Cmo algunos objetos se refieren a otros, cmo vamos a hacer esto?
            tambin tiene que ver con la forma de comparar objetos y contextos.
      */
    }
  function getObjeto($objx,$cont,$tobj)
    {
      $con=true;
      $tipo=$objx->nodeName; //tipo del objeto
      $narg='';  //nombre del argumento
      $largsx=$objx->childNodes; //lista de argumentos xml
      $largs=array(); //lista de argumentos ObjetosG
      $ltargs=array(); //lista de tipos de los argumentos ObjetosG
      foreach($largsx as $argx)
	if($argx->nodeName !='#text')
	  {
	    if($argx->nodeName =='arg') //si es una referencia a otro objeto
	      $narg=$argx->getAttribute('name'); //asignamos el nombre del objeto referenciado
	    else
	      $narg=$this->getObjeto($argx,$cont,$tobj); //si es un objeto anidado vamos a extraerlo
	    $arg=$cont->getObjByName($narg);
	    if($arg != null) //si encontramos el objeto
	      {
		$con = $con && $arg->conocido();
		$largs[]=$narg; //preferimos usar la referencia a los objetos
		$ltargs[]=$arg->tipo();
		//$largs[]=$arg;
	      }
	    else
	      print "Carga de Memoria: No se encontr el objeto argumento $narg en el contexto acutal.\n";
	  }
      if($tobj=='')
	$tobj=($con)?'c':'d';
      $nombre='';
      $nombrex=$objx->getAttribute('name');
      if($nombrex) //si el objeto no es annimo
	$nombre=$nombrex;
      else //pero si es annimo
	$nombre=$cont->anonimo(); //pedimos un nombre al contexto
      if($tipo =='op') //si lo que tenemos es un operador
	{
	  $oper=$objx->getAttribute('oper');
	  $tipo=$objx->getAttribute('type');
	  $cont->addObjetoG(new Operador($oper,$tipo,$nombre,$largs,$ltargs),$tobj);
	}
      else
	$cont->addObjetoG(new ObjetoG($tipo,$nombre,$largs,$ltargs),$tobj);
      return $nombre;
    }
  function getRels($listax,$cont,$trel) //extrae las relaciones
    {
      $nodos=$listax->childNodes;
      //print_r($nodos);
      if($nodos)
	foreach($nodos as $rel)
	  if($rel->nodeName != '#text')
	    $this->getRel($rel,$cont,$trel);
    }
  function getRel($relx,$cont,$trel)
    {
      $narg=''; //nombre del argumento
      $largsx=$relx->childNodes; //lista de argumentos xml
      $largs=array(); //lista de argumentos ObjetoG
      $ltargs=array(); //lista de los tipos de los argumentos ObjetoG
      foreach($largsx as $argx) //revisamos cada argumento
	if($argx->nodeName != '#text')
	  {
	    if($argx->nodeName == 'arg') //si es una referencia a otro objeto
	      $narg=$argx->getAttribute('name');
	    else
	      $narg=$this->getObjeto($argx,$cont,''); //si es un objeto anidado vamos a extraerlo AQUI puede haber problemas al dejar que se decida si el objeto es conocido o desconocido
	    $arg=$cont->getObjByName($narg);
	    if($arg) //si encontramos el objeto
	      {
		$largs[]=$narg; //preferimos la referencia a los objetos
		$ltargs[]=$arg->tipo();
		//$largs[]=$arg;
	      }
	    else
	      print "Carga de Memoria: No se encuentr el objeto argumento $narg en el contexto actual.\n";
	  }
      $nombre=$relx->getAttribute('name'); //nombre de la relacin
      $id=$relx->getAttribute('id'); //id de la relacion 
      if($id)
	$cont->addRelacion(new Relacion($nombre,$largs,$ltargs,$id),$trel);
      else
	$cont->addRelacion(new Relacion($nombre,$largs,$ltargs),$trel);
    }
  function getRel2($relx)
    {
      $narg=''; //nombre del argumento
      $largsx=$relx->childNodes; //lista de argumentos xml
      $largs=array(); //lista de argumentos ObjetoG
      $ltargs=array(); //lista de los tipos de los argumentos ObjetoG
      foreach($largsx as $argx) //revisamos cada argumento
	if($argx->nodeName != '#text')
	  {
	    if($argx->nodeName == 'arg') //se es una referencia a otro objeto
	      {
		$narg=$argx->getAttribute('name');
		$targ=$argx->getAttribute('type');
	      }
	    $largs[]=$narg; //preferimos la referencia a los objetos
	    $ltargs[]=$targ;
	  }
      $nombre=$relx->getAttribute('name'); //nombre de la relacin
      return new Relacion($nombre,$largs,$ltargs);
    }
  function getPasos($pasosX,$cont) //extrae los pasos de la solucion
    {
      $pasos=array();
      foreach($pasosX->childNodes as $paso)
	if($paso->nodeName != '#text')
	  $pasos=array_merge($pasos,$this->getPaso($paso,$cont));
      return $pasos;
    }
  function getPaso($pasox,$cont)
    {
      $paso=array();
      $largs=array(); //lista de argumentos strings y acciones
      $resuelve=array();
      $satisface=array();
      $oper='';
      $tipo=$pasox->nodeName; //tipo del oobjeto a crear
      $largsx=$pasox->childNodes; //lista de argumentos
      foreach($largsx as $argx) //revisamos cada argumento
	if($argx->nodeName != '#text')
	  {
	    if($argx->nodeName == 'arg') //si es una referencia a un objeto
	      {
		$nargx=$argx->getAttribute('name'); //atributo xml con el nombre
		$narg='_'; //nombre annimo por omisin
		if($nargx != null) //si no es annimo
		  $narg=$nargx; //tomamos el nombre
		else//si es annimo puede ser un booleano
		  {
		    $nargx=$argx->getAttribute('value');
		    if($nargx != null)
		      $narg=$nargx;
		  }
		$largs[]=$narg; //agrega el nombre del objeto referenciado
	      }
	    elseif($argx->nodeName == 'res')
	      {
		$resuelve[]=$argx->getAttribute('name');
	      }
	    elseif($argx->nodeName == 'sat' )
	      {
		$id=$argx->getAttribute('id');
		if($id)
		  {
		    $rel=clone $cont->getRelById($id);
		    //$rel->_print(true);
		    if($rel)
		      $satisface[]=$rel;
		  }
		else
		  { //la relacion se explicita aqui
		    foreach($argx->getElementsByTagName('rel') as $relx)
		      $satisface[]=$this->getRel2($relx);
		  }
	      }
	    else //pero si es un objeto anidado
	      {
		$anidado=$this->getPaso($argx,$cont);
		$paso=array_merge($paso,$anidado);
		//print_r($anidado);
		$largs[]=$anidado[count($anidado)-1]->nombre(); //agregamos el paso anidado
	      }
	  }
      $nombre='';
      $nombrex=$pasox->getAttribute('name');
      if($nombrex != null) //si el objeto no es annimo
	$nombre=$nombrex;
      else //pero si es annimo
	$nombre='_'; //lo marcamos como annimo
      if($tipo == 'op')  //si lo que tenemos es un operador
	{
	  $oper=$pasox->getAttribute('oper');
	  $tipo=$pasox->getAttribute('type');
	}
      if($tipo == 'draw' or $tipo =='label')
	$pas= new Accion($tipo,$largs);
      else
	$pas= new Accion($tipo,$largs,$nombre,$oper);
      $pas->resuelve($resuelve);
      $pas->satisface($satisface);
      $paso[]=$pas;
      return $paso;
    }
  function getDefine($defineX)
    {
      $op=$this->getOpDef($defineX->getElementsByTagName('op')->item(0));
      $define=null;
      if($op)
	$define=new OpNuevo($op);
      return $define;
    }
  function getOpDef($opx)
    {
      $tipo=$opx->nodeName; //tipo del objeto
      $narg='';  //nombre del argumento
      $largsx=$opx->childNodes; //lista de argumentos xml
      $largs=array(); //lista de argumentos ObjetosG
      $ltargs=array(); //lista de tipos de los argumentos ObjetosG
      foreach($largsx as $argx)
	if($argx->nodeName !='#text')
	  {
	    if($argx->nodeName =='arg') //si es una referencia a otro objeto
	      $narg=$argx->getAttribute('name'); //asignamos el nombre del objeto referenciado
	    else
	      $narg=$this->getOpDef($argx); //si es un objeto anidado vamos a extraerlo En la prctica no se va a usar
	    //$arg=$cont->getObjByName($narg);
	    $largs[]=$narg; //preferimos usar la referencia a los objetos
	    $ltargs[]=$argx->getAttribute('type');
	  }
      $nombre=$opx->getAttribute('name');
      if($tipo =='op') //si lo que tenemos es un operador
	{
	  $oper=$opx->getAttribute('oper');
	  $tipo=$opx->getAttribute('type');
	  //print "new Operador($oper,$tipo,$nombre,$largs,$ltargs)\n";
	  return new Operador($oper,$tipo,$nombre,$largs,$ltargs);
	}
      else
	return new ObjetoG($tipo,$nombre,$largs,$ltargs);
    }
	
}

/*         Clase CtIndex                 */
class CtIndex
{ //Objeto que representa un indice de contextos
  var $conocidos; //Indice por conocidos
  var $desconocidos; //Indice por desconocidos
  var $satisfechas; //Indice por relaciones satisfechas
  var $insatisfechas; //Indice por relaciones insatisfechas
  function CtIndex()
    {
      $this->conocidos= new ORIndex();
      $this->desconocidos= new ORIndex();
      $this->satisfechas= new ORIndex();
      $this->insatisfechas= new ORIndex();
    }
  function clase()
    {
      return 'CtIndex';
    }
  function searchCt($contexto,$caso,$match)
    { //Funcin para buscar un contexto, caso es "e" (exacto) o "i" (incluido)
      if($caso=='e' or count($contexto->getConocidos()))
	$listasContextos[]=$this->conocidos->searchCt($contexto->getConocidos(),$caso,$match);
      if($caso=='e' or count($contexto->getDesconocidos()))
	$listasContextos[]=$this->desconocidos->searchCt($contexto->getDesconocidos(),$caso,$match);
      if($caso=='e' or count($contexto->getSatisfechas()))
	$listasContextos[]=$this->satisfechas->searchCt($contexto->getSatisfechas(),$caso,$match);
      if($caso=='e' or count($contexto->getInsatisfechas()))
	$listasContextos[]=$this->insatisfechas->searchCt($contexto->getInsatisfechas(),$caso,$match);
      return SetsCap($listasContextos);
    }
  function addCt($contexto,$idCont)
    {
      $this->conocidos->addCt($contexto->getConocidos(),$idCont);
      $this->desconocidos->addCt($contexto->getDesconocidos(),$idCont);
      $this->satisfechas->addCt($contexto->getSatisfechas(),$idCont);
      $this->insatisfechas->addCt($contexto->getInsatisfechas(),$idCont);
    }
}

/*       clase OrIndex                   */
class OrIndex
{
  var $clases=array(); //clases de objetos o relaciones indexadas

  function ORIndex()
    {
    }
  function clase()
    {
      return 'OrIndex';
    }
  function addCt($ORs,$idCont)
    {
      $cantidades=array();
      foreach($ORs as $OR)
	{
	  $clase='';
	  $objeto=$OR->clase();
	  if($objeto == 'Relacion')
	    $clase=$OR->nombre();
	  else
	    $clase=$OR->tipo(); //tambin hay operadores
	  @$cantidades[$clase]++;
	}
      foreach($cantidades as $clase => $cantidad)
	{
	  $indice=0;
	  /*
					if($this->clases[$clase])
						$indice=$this->clases[$clase];
					else
						$indice= new Indice();
					$indice->addObj($cantidad,$idCont);
					$this->clases[$clase]=$indice;*/
	  if(! isset($this->clases[$clase]))
	    $this->clases[$clase]=new Indice();
	  $this->clases[$clase]->addObj($cantidad,$idCont);
	}
    }
  function searchCt($ORs,$caso,$match)
    {
      $cantidades=array();
      foreach($ORs as $OR)
	{
	  $objeto=$OR->clase();
	  $clase='';
	  if($objeto=='Relacion')
	    $clase=$OR->nombre();
	  else
	    $clase=$OR->tipo();
	  @$cantidades[$clase]++;
	}
      $listasContextos=array();
      foreach($cantidades as $clase => $cantidad)
	{
	  if(isset($this->clases[$clase]))
	    {
	      $listatemp=$this->clases[$clase]->getContextos($cantidad,$caso,$match); //esto es para evitar las listas vacias pues ocasionan devolver una lista vacia.
	      if(count($listatemp))
		$listasContextos[]=$listatemp;
	    }
	}
      return SetsCap($listasContextos);
    }
}

/*              clase Indice            */
class Indice
{
  var $indice;
  function Indice()
    {
      $this->indice=array();
    }
  function clase()
    {
      return 'Indice';
    }
  function addObj($cantidad,$idCont)
    {
      if(! isset($this->indice[$cantidad]))
	{
	  $this->indice[$cantidad]=array();
	}
      array_push($this->indice[$cantidad],$idCont);
    }
  function getContextos($cantidad,$caso,$match)
    {
      $listasContextos=array();
      if($caso == 'e')//busqueda exacta
	{
	  if(is_array($this->indice[$cantidad]))
	    return $this->indice[$cantidad];
	  return $listasContextos;
	}
      if($caso == 'd')//busqueda dentro de un margen
	{
	  $li= $cantidad*$match;
	  $ls= $cantidad/$match;
	}
      else
	{//busqueda de contexto incluido
	  $li=$cantidad;
	  //$ls=$cantidad/($match*$match);
	  $ls=1000; //un nmero suficientemente grande
	}
      $li=floor($li);
      $ls=ceil($ls);
      //print "LI: $li,LS: $ls\n";
      ksort($this->indice);
      foreach($this->indice as $cant => $lista)
	{
	  if($cant >= $li and $cant <= $ls)
	    {
	      $listasContextos[]=$lista;
	    }
	}
      return SetsCup($listasContextos);
    }
}

/*            clase AccAsoc               */
class AccAsoc
{ //La lista de acciones asociadas y los mapeos correspondientes.
  var $acciones; //esta tabla esta indexada por las acciones y contiene informacin adicional a la asociacin como el mapeo entre los objetos del contexto y el de la accin.
  function AccAsoc($AccId=null,$mapeo=null)
    {
      $this->acciones=array();
      if(isset($AccId))
	$this->add($AccId,$mapeo);
    }
  function clase()
    {
      return 'AccAsoc';
    }
  function add($AccId,$mapeo)
    {
      if(! isset($this->acciones[$AccId]))
	$this->acciones[$AccId]=new InfoAccAsoc();
      $this->acciones[$AccId]->add($mapeo);
    }
  //falta una funcin para recuperar un id de accion y su informacion adicional.
  function get($AccId=null)
    {
      if($AccId)
	return $this->acciones[$AccId]->get(); //devuelve los mapeos entre el contexto y la accin
      else
	return $this->acciones;
    }
  function _print($imprime=false)
    {
      $texto='';
      foreach($this->acciones as $ai => $iaa)
	$texto.="\tId Accin Asociada: $ai\n".$iaa->_print();
      if($imprime)
	print "$texto\n";
      return $texto;
    }
}

/*     clase InfoAccAsoc                */
class InfoAccAsoc
{ //Informacin adicional a la accin asociada (mapeo entre los objetos del  contexto y de la accin)
  var $mapeos;
  function InfoAccAsoc($mapeo=null)
    {
      $this->mapeos=array();
      if(isset($mapeo))
	array_push($this->mapeos,$mapeo);
    }
  function clase()
    {
      return 'InfoAccAsoc';
    }
  function add($mapeo)
    {
      if(! in_array($mapeo,$this->mapeos))
	array_push($this->mapeos,$mapeo);
    }
  function get()
    {
      return $this->mapeos;
    }
  function _print($imprime=false)
    {
      $texto='';
      foreach($this->mapeos as $m)
	{
	  $texto.="\t\t[";
	  $keys=$m->keys();
	  $nk=count($keys);
	  for($j=0;$j<$nk;$j++)
	    {
	      $k=$keys[$j];
	      $v=$m->value($k);
	      $texto.="$k>$v";
	      if($j<$nk-1)
		$texto.=' ';
	    }
	  $texto.="]\n";
	}
      if($imprime)
	print $texto;
      return $texto;
    }
}

/*      funcin interseccin de conjuntos     */
function SetsCap($conjuntos=array())
{
  $resultado=array();
  $nconj=count($conjuntos);
  if($nconj > 0)
    {
      $base=$conjuntos[0];
      foreach($base as $el)
	{
	  $pertenece=true;
	  for($i=1; $i<$nconj;$i++)
	    {
	      if(! in_array($el,$conjuntos[$i]))
		{
		  $pertenece=false;
		  break 1;
		}
	    }
	  if($pertenece)
	    $resultado[]=$el;
	}
    }
  return $resultado;
}

/*        funcin unin de conjuntos       */
function SetsCup($conjuntos=array())
{
  $resultado=array();
  foreach($conjuntos as $conj)
    {
      foreach($conj as $el)
	{
	  if(! in_array($el,$resultado))
	    $resultado[]=$el;
	}
    }
  return $resultado;
}

/*         clase Contexto          */
class Contexto
{
  var $Conocidos=array();
  var $Desconocidos=array();
  var $Satisfechas=array();
  var $Insatisfechas=array();
  var $contAnonimos=1;
  var $mDisp=array();
  var $MDisp=array();
  var $CDisp=array();


  function Contexto($conocidos=array(),$desconocidos=array(),$satisfechas=array(),$insatisfechas=array())
    {
      global $mDisp,$MDisp,$CDisp;
      $this->Conocidos=$conocidos;
      $this->Desconocidos=$desconocidos;
      $this->Satisfechas=$satisfechas;
      $this->Insatisfechas=$insatisfechas;
      $this->contAnonimos=1;
      $this->mDisp=$mDisp;
      $this->MDisp=$MDisp;
      $this->CDisp=$CDisp;
      foreach($this->Conocidos as $c)
	$this->actualizaNombres($c->nombre());
      foreach($this->Desconocidos as $c)
	$this->actualizaNombres($c->nombre());
    }
  function clase()
    {
      return 'Contexto';
    }
  function __clone()
    {
      $arreglos=array('Conocidos','Desconocidos','Satisfechas','Insatisfechas');
      foreach($arreglos as $lista)
	foreach($this->$lista as $k=>$v)
	  $this->{$lista}[$k]= clone $v;
    }
  function getObjByName($nombre,$donde=1) //Donde: 0 conocidos,1 ambos, 2 desconocidos
    {
      if($donde<2)
	foreach ($this->Conocidos as $con)
	  {
	    if($con->nombre() == $nombre)
	      return $con;
	  }
      if($donde>0)
	foreach ($this->Desconocidos as $desc)
	  {
	    if($desc->nombre() == $nombre)
	      return $desc;
	  }
      return null;
    }
  function addConocido($obj)
    {
      $nombre=$obj->nombre();
      $desc=$this->getObjByName($nombre,2);
      if($desc)
	{//si este objeto est entre los desconocidos
	  $this->rmDesconocido($desc);
	}
      $obj->setConocido(true);
      array_push($this->Conocidos,$obj);
      $this->actualizaNombres($nombre);
    }
  function getConocidos()
    {
      return $this->Conocidos;
    }
  function addDesconocido($obj)
    {
      $obj->setConocido(false);
      array_push($this->Desconocidos,$obj);
      $this->actualizaNombres($obj->nombre());
    }
  function rmDesconocido($obj)
    {
      $Idx=array_search($obj,$this->Desconocidos);
      if($Idx !== false)
	unset($this->Desconocidos[$Idx]);
    }
  function getDesconocidos()
    {
      return $this->Desconocidos;
    }
  function addObjetoG($obj,$caso)
    {
      if($caso == 'c')
	$this->addConocido($obj);
      if($caso == 'd')
	$this->addDesconocido($obj);
      //print 'Se agrega al contexto el objeto de nombre '. $obj->nombre().".\n";
    }
  function setConocido($nobj)
    {
      //print "%%% set Conocido $nobj:\n";
      //$this->_print(true);
      $sinrel=$this->sinRelIns($nobj);
      //print "|$sinrel|\n";
      if($sinrel)
	foreach($this->Desconocidos as $k => $obj)
	  if($obj->nombre() ==$nobj )
	    {
	      $this->addConocido($obj);
	      unset($this->Desconocidos[$k]);
	      break;
	    }
    }
  function setDesconocido($nobj)
    {
      foreach($this->Conocidos as $k => $obj)
	if($obj->nombre() ==$nobj )
	  {
	    $this->addDesconocido($obj);
	    unset($this->Conocidos[$k]);
	    break;
	  }
    }
  function addSatisfecha($rel)
    {
      array_push($this->Satisfechas,$rel);
    }
  function getSatisfechas()
    {
      return $this->Satisfechas;
    }
  function addInsatisfecha($rel)
    {
      array_push($this->Insatisfechas,$rel);
    }
  function rmInsatisfecha($rel)
    {
      $Idx=array_search($rel,$this->Insatisfechas);
      if($Idx !== false)
	unset($this->Insatisfechas[$Idx]);
    }
  function getInsatisfechas()
    {
      return $this->Insatisfechas;
    }
  function addRelacion($rel,$caso)
    {
      if($caso == 's')
	$this->addSatisfecha($rel);
      if($caso == 'i')
	$this->addInsatisfecha($rel);
      //print 'Se agrega al contexto el objeto de nombre '. $obj->nombre().".\n";
    }
  function getRelById($id)
    {
      foreach($this->Satisfechas as $r)
	if($r->id() == $id)
	  return $r;
      foreach($this->Insatisfechas as $r)
	if($r->id() == $id)
	  return $r;
      return null;
    }
  function setSatisfecha($rel)
    { //hay que ver si la relacion est entre las desconocidas para poderla borrar.
      foreach($this->Insatisfechas as $k =>$otra)
	if($rel->equal($otra))
	  {
	    unset($this->Insatisfechas[$k]);
	    break;
	  }
      $this->addSatisfecha($rel);
    }
  function sinRelIns($nombreObj)
    {//decide si el objeto nombrado no tiene relaciones insatisfechas
      //esto no basta hay que revisar ms a fondo
      $examinados=array();
      foreach($this->Insatisfechas as $r)
	{
	  $args=$r->interv();
	  foreach($args as $a)
	    {
	      if($this->buscaConDependencias($nombreObj,$a,$examinados))
		return false;
	    }
	}
      return true;
    }
  function buscaConDependencias($aguja,$nobj,&$vistos)
    { //busca la aguja en el objeto y sus dependencias
      if(in_array($nobj,$vistos))
	return false;
      if($aguja==$nobj)
	return true;
      $vistos[]=$nobj;
      $obj=$this->getObjByName($nobj);
      $resultado=false;
      if($obj)
	{
	  $args=$obj->args();
	  foreach($args as $a)
	    if($this->buscaConDependencias($aguja,$a,$vistos))
	      return true;
	}
      return false;
    }
  function anonimo()
    {
      $CA=$this->contAnonimos++;
      return "_$CA";
    }
  function nuevoNombre($tipo='point')
    {
      //print "$tipo\n";
      reset($this->mDisp);
      reset($this->MDisp);
      reset($this->CDisp);
      if(in_array($tipo,array('line','ray','segment','distance')))
	{
	  $tmp=each($this->mDisp);
	  return $tmp[1];
	}
      elseif(in_array($tipo,array('circle','arc')))
	{
	  $tmp=each($this->CDisp);
	  return $tmp[1];
	}
      $tmp=each($this->MDisp);
      return $tmp[1];
    }
  function comp($otro,$mapPrev=null)
    {/*compara este contexto con otro y devuelve un arreglo que contiene
       el ranking de la comparacion (elementos emparejados/ total de elementos en el otro contexto) y
       un mapeo de objetos del otro contexto a este.*/
      //Esta funcin debe ser mejorada para encontrar todos los mapeos posibles: NP completo?
      $emparejados=0;
      $elementos=0;
      $rank=0;
      $mapeo=new Mapeo();
      if($mapPrev)
	$mapeo=$mapPrev;
      $resultados=array();
      $mapeoORs=new MapeoOR();
      //primero vemos qu objetos o relaciones pueden corresponder
      $this->compL($this->getConocidos(),$otro->getConocidos(),$mapeoORs);
      $this->compL($this->getDesconocidos(),$otro->getDesconocidos(),$mapeoORs);
      $this->compL($this->getSatisfechas(),$otro->getSatisfechas(),$mapeoORs);
      $this->compL($this->getInsatisfechas(),$otro->getInsatisfechas(),$mapeoORs);
      //luego vamos emparejando objetos y relaciones y hacemos el mapeo
      //para cada Objeto-Relacion, empezando por el que tiene menos posibilidades de emparejamiento, hasta el que tiene ms
      foreach ($mapeoORs->tamanios() as $npos)
	{
	  $ORtpos=$mapeoORs->getBySize($npos); //Esto nos trae todos los objetos (y sus posibles emparejamientos) con $npos posibles emparejamientos
	  $tipo='';
	  $li=$ORtpos->lastIndex();
	  for($mm=0;$mm<=$li;$mm++)
	    { //para cada objeto con $npos posibles emparejamientos
	      $ORt=$ORtpos->getLlave($mm); //Obtenemos el objeto
	      $posibles=$ORtpos->getPosibles($mm); //Obtenemos sus posibles emparejamientos
	      $tipo=$ORt->clase();
	      $elementos++;
	      foreach($posibles as $posible)
		{
		  $conflicto=false;
		  $maptemp=new Mapeo();
		  $tArgs='';
		  $oArgs='';
		  if($tipo == 'Relacion')
		    {
		      $tArgs=$ORt->interv();
		      $oArgs=$posible->interv();
		    }
		  else
		    {
		      $tArgs=$ORt->args();
		      $oArgs=$posible->args();
		      $tnombre=$ORt->nombre();
		      $onombre=$posible->nombre();
		      if($mapeo->contieneLlave($onombre))
			$conflicto=($mapeo->value($onombre) != $tnombre); //conflicto en el mapeo
		      else
			if($mapeo->contiene($tnombre)) //conflicto
			  $conflicto=true;
			else //podemos mapear el otro con este
			  {
			    $maptemp->map($onombre,$tnombre);
			    $conflicto=false;
			  }
		    }
		  //ahora revisamos los argumentos
		  $tArgsSize=count($tArgs);
		  if ($tArgsSize == count($oArgs) && !$conflicto)
		    {
		      for($nn=0;$nn < $tArgsSize; $nn++)
			{
			  //$tObj=$tArgs[$nn];
			  //$oObj=$oArgs[$nn];
			  //$tnombre=$tObj->nombre();
			  //$onombre=$oObj->nombre();
			  $tnombre=$tArgs[$nn]; //preferimos las referencias
			  $onombre=$oArgs[$nn];
			  if($onombre=='true' or $onombre=='false')
			    {
			      if($onombre!=$tnombre)
				$conflicto=true;
			      else
				$maptemp->map($onombre,$tnombre);
			    }
			  elseif($mapeo->contieneLlave($onombre))
			    $conflicto=($mapeo->value($onombre) != $tnombre); //conflicto en el mapeo
			  else
			    if($mapeo->contiene($tnombre)) //conflicto
			      $conflicto=true;
			    else // podemos mapear el otro con este
			      $maptemp->map($onombre,$tnombre);
			  if($conflicto)
			    break;
			}
		    }
		  //elseif($tipo=='ObjetoG' && $tArgSize >0 && $count($oArgs)==0 && !$conflicto)
		  //{
		  //}
		  if(!$conflicto)
		    { //si no hubo conflictos podemos mapear los elementos de esta posibilidad con los de este objeto
		      $mapeados=$maptemp->size();
		      $emparejados++;
		      $mapeo->add($maptemp);
		      break;
		    }
		}
	    }
	}
      if($elementos==0)
	$rank=0;
      else
	{
	  //$rank=$emparejados/$elementos;
	  $telementos=count($this->Conocidos)+count($this->Desconocidos)+count($this->Satisfechas)+count($this->Insatisfechas);
	  $rank=sqrt($emparejados/$telementos);
	  //$rank=($emparejados/$elementos)*sqrt(sqrt($emparejados/$telementos));
	}
      $resultado['rank']=$rank;
      $resultado['mapeo']=$mapeo;
      //print "***Contexto Candidato\n";
      //$this->_print(true);
      //print "// rank: $rank, mapeo: ". $mapeo->_print();
      return $resultado;
    }
  function compL($esteOR,$otroOR,&$mapeoOR)
    {//est hecha para ver si 2 contextos son idnticos
      if(count($otroOR))
	{
	  foreach($esteOR as $eOR)
	    {
	      $posibles=array();
	      $posibles=$eOR->buscaEn($otroOR);
	      $mapeoOR->add($eOR,$posibles);
	    }
	}
    }
  function relacionadosCon($obj,$relacion,$permitidos)
    {
      $resultado=array();
      $relacionados=$relacion->interv();
      $nombre=$obj->nombre();
      if(in_array($nombre,$relacionados))
	foreach($relacionados as $nobjrel)
	  {
	    if($nombre!=$nobjrel)
	      {
		$objrel=$this->getObjByName($nobjrel);
		if($objrel->conocido())
		  {
		    if(!in_array($nobjrel,$permitidos))
		      $resultado[]=$nobjrel;
		  }
		elseif(!in_array($nobjrel,$permitidos))
		  return array(); //si alguno de los relacionados es desconocido o no es de los permitidos, mejor no devolvemo ninguno.
	      }
	  }
      return $resultado;
    }
  function hijosDe(&$padres)
    {
      $resultado=array();
      foreach($this->getConocidos() as $conocido)
	{
	  $esBueno=true;
	  $ncon=$conocido->nombre();
	  if(!in_array($ncon,$padres))
	    {
	      foreach($conocido->args() as $arg)
		if(!in_array($arg,$padres))
		  {
		    $esBueno=false;
		    break;
		  }
	      if(count($conocido->args()) and $esBueno)
		{
		  $padres[]=$ncon;
		  $resultado[]=$ncon;
		}
	    }
	}
      return $resultado;
    }
  function agregaConDependencias($obj,$nuevoC,&$relacionados)
    {
      $nobj='';
      if(is_object($obj)) //si es un objeto
	{
	  $nobj=$obj->nombre();
	}
      else //si no es un objeto es una referencia
	{
	  $nobj=$obj;
	  $obj=$this->getObjByName($nobj);
	}
      if($obj and !$nuevoC->getObjByName($nobj)) //agregamos el objeto
	{
	  $dc=$obj->conocido();
	  $nuevoC->addObjetoG($obj,(($dc)?'c':'d'));
	  if(! in_array($nobj,$relacionados))
	    $relacionados[]=$nobj;
	}
      else //si el objeto no existe
	return false;
      //ahora agregamos las dependencias
      $args=$obj->args();
      foreach($args as $a)
	{
	  $this->agregaConDependencias($a,$nuevoC,$relacionados);
	}
    }
  function subContexto($pista)
    { //devuelve la parte del contexto que depende de la pista.
      $resultado=new Contexto();
      $relacionados=array();
      if($pista->clase() == 'ObjetoG' or $pista->clase() == 'Operador')
	{
	  //la pista es un objeto desconocido, vamos a agregarla al resultado, junto con sus dependencias.
	  $this->agregaConDependencias($pista,$resultado,$relacionados);
	  //Ahora agregamos las relaciones insatisfechas que solamente relacionan a los objetos en relacionados u objetos nuevos.
	  foreach($this->Insatisfechas as $ins)
	    {
	      //aqui quiero los objetos relacionados con pista en las relaciones que no incluyen otros desconocidos, salvo los que ya estn en $relacionados.
	      $temp=$this->relacionadosCon($pista,$ins,$relacionados);
	      if(count($temp))
		{
		  $resultado->addInsatisfecha($ins);
		  foreach($temp as $obj)
		    {
		      $this->agregaConDependencias($obj,$resultado,$relacionados);
		      //if(!in_array($obj,$relacionados))
		      //$relacionados[]=$obj;
		    }
		}
	    }
	  //a lo mejor sea bueno aqui ampliar la lista de relacionados con los objetos que dependen de los que ya estn en esa lista.
	  $temp=$this->hijosDe($relacionados);
	  foreach($temp as $obj)
	    $this->agregaConDependencias($obj,$resultado,$relacionados);
	  foreach($this->Satisfechas as $sat)
	    if($sat->relacionadosEn($relacionados)) //aqui quiero saber si los objetos que relaciona sat estan todos en $relacionados
	      $resultado->addSatisfecha($sat);
	}
      elseif($pista->clase()=='Relacion')
	{
	  $relacionados=$pista->interv();
	  //a lo mejor sea bueno aqui ampliar la lista de relacionados con los objetos que dependen de los que ya estn en esa lista.
	  $this->hijosDe($relacionados);
	  $resultado->addInsatisfecha($pista);
	  foreach($this->Satisfechas as $sat)
	    if($sat->relacionadosEn($relacionados))
	      $resultado->addSatisfecha($sat);
	  foreach($relacionados as $nobj) //quizas estos 2 foreach deben ir en orden inverso
	    $this->agregaConDependencias($nobj,$resultado,$relacionados);
	}
      return $resultado;
    }
  function actualizaNombres($nombre)
    {
      $idx=array_search($nombre,$this->mDisp);
      if($idx !== false)
	{
	  unset($this->mDisp[$idx]);
	  $this->mDisp[]=$nombre."'";
	}
      $idx=array_search($nombre,$this->MDisp);
      if($idx !== false)
	{
	  unset($this->MDisp[$idx]);
	  $this->MDisp[]=$nombre."'";
	}
      $idx=array_search($nombre,$this->CDisp);
      if($idx !== false)
	{
	  unset($this->CDisp[$idx]);
	  $this->CDisp[]=$nombre."'";
	}
    }
  function ProbNvo($faltante,$CtLTM) //**POR HACER
    {//esta funcin determina si el objeto faltante no existe en este contexto
      //en cuyo caso genera un problema nuevo para construir el objeto faltante.
    }
  function _print($imprime=false)
    {
      $texto='';
      $texto.="\t --  Conocidos  --\n";
      foreach($this->Conocidos as $c)
	$texto.="\t\t".$c->_print()."\n";
      $texto.="\t -- Desconocidos --\n";
      foreach($this->Desconocidos as $d)
	$texto.="\t\t".$d->_print()."\n";
      $texto.="\t -- Satisfechas --\n";
      foreach($this->Satisfechas as $s)
	$texto.="\t\t".$s->_print()."\n";
      $texto.="\t -- Insatisfechas --\n";
      foreach($this->Insatisfechas as $i)
	$texto.="\t\t".$i->_print()."\n";
      if($imprime)
	print "$texto\n";
      return $texto;
    }
  function xml(&$doc,&$nodo)
    {
      $contexto=$doc->createElement('contexto');
      $contexto=$nodo->appendChild($contexto);
      $listas=array('Conocidos'=>'conocidos',
		    'Desconocidos'=>'desconocidos',
		    'Satisfechas'=>'satisfechas',
		    'Insatisfechas'=>'insatisfechas');
      foreach($listas as $k => $v)
	{
	  eval('$lista=$this->'.$k.';');
	  if($lista)
	    {
	      $listas[$k]=$doc->createElement($v);
	      $listas[$k]=$contexto->appendChild($listas[$k]);
	      foreach($lista as $l)
		{
		  $l->xml($doc,$listas[$k]);
		}
	    }
	}
    }
  function applyMap($mapeo,$otroCt=null)
    { //funcin que se aplica al contexto slo cuando es necesario extraer un prerrequisito de una accin asociada a este contexto.
      global $mDisp,$MDisp,$CDisp;
      // $listas=array('Conocidos','Satisfechas');
      $listas=array('Conocidos','Desconocidos','Satisfechas','Insatisfechas');
      $ocupados=array();
      if($otroCt)
	{
	}
      foreach($listas as $l)
	{
	  if($l=='Conocidos')
	    {
	      foreach($this->Conocidos as $o)
		$o->applyMap($mapeo,$ocupados); //crear esta funcin para ObjetoG
	    }
	  if($l=='Desconocidos')
	    {
	      foreach($this->Desconocidos as $o)
		$o->applyMap($mapeo,$ocupados); //crear esta funcin para ObjetoG
	    }
	  if($l=='Satisfechas')
	    {
	      foreach($this->Satisfechas as $r)
		$r->applyMap($mapeo,$ocupados);
	    }
	  if($l=='Insatisfechas')
	    {
	      foreach($this->Insatisfechas as $r)
		$r->applyMap($mapeo,$ocupados);
	    }
	}
      $this->mDisp=$mDisp;
      $this->MDisp=$MDisp;
      $this->CDisp=$CDisp;
      foreach($this->Conocidos as $c)
	$this->actualizaNombres($c->nombre());
      foreach($this->Desconocidos as $c)
	$this->actualizaNombres($c->nombre());
    }
}

/*      clase MapeoOR           */
class MapeoOR
{
  var $llaves=array();
  var $valores=array();
  var $tamanios=array();
  var $sizes=array();
  var $lastindex;
  var $currentindex;
  var $maxsize;

  function MapeoOR()
    {
      $this->lastindex=-1;
      $this->currentindex=0;
      $this->maxsize=0;
    }
  function clase()
    {
      return 'MapeoOR';
    }
  function add($llave,$valor)
    {
      $this->lastindex++;
      array_push($this->llaves,$llave);
      array_push($this->valores,$valor);
      $tam=count($valor);
      if($tam > $this->maxsize)
	$this->maxsize=$tam;
      if(! in_array($tam,$this->sizes))
	array_push($this->sizes,$tam);
      $temp=array();
      if(isset($this->tamanios[$tam]))
	$temp=$this->tamanios[$tam];
      array_push($temp,$this->lastindex);
      $this->tamanios[$tam]=$temp;
    }
  function getBySize($size)
    {
      $resultado = new MapeoOR();
      $arrayindex=$this->tamanios[$size];
      foreach($arrayindex as $indiceElemento)
	{
	  $resultado->add($this->llaves[$indiceElemento],$this->valores[$indiceElemento]);
	}
      return $resultado;
    }
  function isEmpty()
    {
      return ($this->lastindex <0);
    }
  function lastIndex()
    {
      return $this->lastindex;
    }
  function maxSize()
    {
      return $this->maxsize;
    }
  function tamanios()
    {
      sort($this->sizes,SORT_NUMERIC);
      return $this->sizes;
    }
  function getLlave($ind)
    {
      return $this->llaves[$ind];
    }
  function getPosibles($ind)
    {
      return $this->valores[$ind];
    }
}

/*     clase ObjetoG           */
class ObjetoG
{
  var $nombre;
  var $tipo;
  var $args;
  var $tipos;
  var $con=false;
  var $rels=array();

  function ObjetoG($tipo,$nombre,$args=array(),$tipos=array())
    {
      $this->tipo=$tipo;
      $this->nombre=$nombre;
      if(is_object($args))
	{
	  array_push($this->args,$args);
	  print "Se usa $args=objeto en ObjetoG constructor\n";
	}
      else
	$this->args=$args;
      $this->tipos=$tipos;
    }
  function clase()
    {
      return 'ObjetoG';
    }
  function addRel($rel)
    {
      array_push($this->rels,$rel);
    }
  function nombre() //nombre del objeto
    {
      return $this->nombre;
    }
  function tipo() //tipo del objeto
    {
      return $this->tipo;
    }
  function tpreq() //tipo de los prerrequisitos
    {
      //$tpreq=array();
      //foreach($this->args as $arg)
      //$tpreq[]=$arg->tipo();
      //return $tpreq;
      return $this->tipos;
    }
  function args() // objetos que ocupan el lugar de los prerrequisitos
    {
      return $this->args;
    }
  function conocido() //si el objeto es conocido
    {
      return $this->con;
    }
  function setConocido($estado) //cambia el estado de conocido
    {
      $this->con=$estado;
    }
  function rels() //relaciones en que interviene el objeto
    {
      return $this->rels;
    }
  function isOper()
    {
      return false;
    }
  function buscaEn($otros) //Devuelve los Objetos que coinciden con este en una lista de otros ObjG
    {
      $posibles=array();
      foreach($otros as $otro)
	{
	  if($this->comp($otro))
	    $posibles[]=$otro;
	}
      return $posibles;
    }
  function comp($otro)
    {
      $resp=true;
      //$nivel--;
      //if($nivel>=0)
      //{
      if($this->tipo()==$otro->tipo() and $this->isOper() == $otro->isOper())
	{
	  $tArgs=$this->args();
	  $tTipos=$this->tpreq();
	  $oArgs=$otro->args();
	  $oTipos=$otro->tpreq();
	  $nargs=count($tArgs);
	  if($nargs>0 && $nargs == count($oArgs))
	    {
	      for($a=0; $a < $nargs;$a++)
		{
		  /*$tobj=$this->getObjByName($tArgs[$a]);
											 $oobj=$otro->getObjByName($oArgs[$a]);
											 $resp=$resp && $tobj->comp($oobj,$nivel);*///esto no se puede
		  //$resp=$resp && $tArgs[$a]->comp($oArgs[$a],$nivel);
		  $resp=$resp && ($tTipos[$a] == $oTipos[$a]); //si ambos argumentos son del mismo tipo
		}
	      return $resp;
	    }
	  //elseif(count($oArgs)==0)
	  elseif($nargs==0)
	    return true;
	  return false;
	}
      return false;
      //}
      //return true;
    }
  function _print($imprime=false)
    {
      $texto=$this->tipo.' '.$this->nombre.' (';
      $nargs=count($this->args);
      for($j=0;$j<$nargs;$j++)
	{
	  $arg=$this->args[$j];
	  if(is_object($arg))//si el argumento es objeto
	    {
	      $texto.=$arg->_print(); //imprimimos el otro objeto
	    }
	  else //si no es objeto debe ser una referencia
	    $texto.=$arg;
	  if($j < $nargs-1)
	    $texto.=', ';
	}
      $texto.=')';
      if($this->isOper())
	$texto.='*'.$this->nop();
      if($imprime)
	print $texto."\n";
      return $texto;
    }
  function xml(&$doc,&$nodo)
    {
      $objeto='';
      if($this->isOper())
	{
	  $objeto=$doc->createElement('op');
	  $objeto->setAttribute('oper',$this->nop());
	  $objeto->setAttribute('type',$this->tipo);
	}
      else
	$objeto=$doc->createElement($this->tipo);
      $objeto->setAttribute('name',$this->nombre);
      $objeto=$nodo->appendChild($objeto);
      foreach($this->args as $k =>$arg)
	{
	  if(is_object($arg))
	    $arg->xml($doc,$objeto);
	  else
	    {
	      $xarg=$doc->createElement('arg');
	      $tipo=$this->tipos[$k];
	      $xarg->setAttribute('type',$tipo);
	      if($tipo=='boolean')
		$xarg->setAttribute('value',$arg);
	      else
		$xarg->setAttribute('name',$arg);
	      $xarg=$objeto->appendChild($xarg);
	    }
	}
    }
  function applyMap($mapeo,$yaOcupados)
    {
      if($mapeo->contieneLlave($this->nombre))
	$this->nombre=$mapeo->value($this->nombre);
      else
	$this->nombre=$this->nombre;
      for($j=0;$j<count($this->args);$j++)
	{
	  if(is_object($this->args[$j])) //si es un objeto anidado
	    $this->args[$j]->applyMap($mapeo);
	  else //pero si es una referencia
	    {
	      $nvon=$mapeo->value($this->args[$j]);
	      if(!$nvon)
		$nvon=$this->args[$j];
	      $this->args[$j]=$nvon;
	    }
	}
    }
  function nop()
    {
      return '';
    }
}

/*     clase Operador           */
class Operador extends ObjetoG
{
  var $operador;
  function Operador($operador,$tipo,$nombre,$args=array(),$tipos=array())
    {
      $this->operador=$operador;
      parent::ObjetoG($tipo,$nombre,$args,$tipos);
    }
  function clase()
    {
      return 'Operador';
    }
  function isOper()
    {
      return true;
    }
  function nop() //devuelve el nombre del operador
    {
      return $this->operador;
    }
}

/*     clase Relacion           */
class Relacion
{
  var $nombre;
  var $objs;
  var $tipos; //tipos de los objetos relacionados
  var $id=null;

  function Relacion($nombre,$objs=array(),$tipos=array(),$id=null)
    {
      $this->nombre=$nombre;
      $this->objs=$objs;
      $this->tipos=$tipos;
      $this->id=$id;
    }
  function clase()
    {
      return 'Relacion';
    }
  function nombre() //nombre de la relacin
    {
      return $this->nombre;
    }
  function interv() //Objetos relacionados
    {
      return $this->objs;
    }
  function tobjs() //tipos de los objetos relacionados
    {
      //$tobjs=array();
      /*foreach($this->objs as $obj)
				$tobjs[]=$obj->tipo();*/
      //return $tobjs;
      return $this->tipos;
    }
  function id()
    {
      return $this->id;
    }
  function buscaEn($otras=array()) //Devuelve las relaciones que coinciden con esta en una lista de otras relaciones.
    {
      $posibles=array();
      foreach($otras as $otra)
	{
	  if($this->nombre == $otra->nombre and $this->tobjs() == $otra->tobjs())
	    $posibles[]=$otra;
	}
      return $posibles;
    }
  function buscaMapeo($otras=array(),$mapeo)
    {
      $ok=true;
      $cubetas=array();
      foreach($otras as $o)
	{
	  $enmapeo=$this->enMapeo($mapeo,$o);
	  if($enmapeo >0)
	    {
	      if(isset($cubetas[$enmapeo]))
		$cubetas[$enmapeo][]=$o;
	      else
		$cubetas[$enmapeo]=array($o);
	    }
	}
      krsort($cubetas); //ordena las cubetas de mayor a menor en base a la llave
      $tinterv=$this->interv();
      $ninterv=count($tinterv);
      foreach($cubetas as $others)
	{
	  foreach($others as $o)
	    {
	      $ointerv=$o->interv();
	      $ok=true;
	      for($ix=0;$ix<$ninterv && $ok;$ix++)
		{
		  if($mapeo->contieneLlave($tinterv[$ix]))
		    {
		      if($mapeo->value($tinterv[$ix]) != $ointerv[$ix])
			$ok=false;
		    }
		  else
		    {
		      if($mapeo->contiene($ointerv[$ix]))
			$ok=false;
		      $mapeo->map($tinterv[$ix],$ointerv[$ix]);
		    }
		}
	      if($ok)
		return true;
	    }
	}
      return false;
    }
  function enMapeo($mapeo,$otra)
    {
      $respuesta=0;
      $tinterv=$this->interv();
      $ointerv=$otra->interv();
      $ninterv=count($tinterv);
      for($ix=0;$ix<$ninterv;$ix++)
	{
	  if($mapeo->contieneLlave($tinterv[$ix]) && $mapeo->value($tinterv[$ix]) == $ointerv[$ix])
	    $respuesta++;
	}
      return $respuesta;
    }
  function relacionaA($obj)
    {
      $nombre=$obj;
      $resultado=array();
      if(is_object($obj))
	$nombre=$obj->nombre();
      if(in_array($nombre,$this->objs))
	{
	  $resultado=$this->objs;
	}
      return $resultado;
    }
  function relacionadosEn($lista)
    {
      foreach($this->objs as $obj)
	if(! in_array($obj,$lista))
	  return false;
      return true;
    }
  function equal($otra)
    {
      return($this->nombre == $otra->nombre and $this->tobjs() == $otra->tobjs() and $this->objs == $otra->objs);
    }
  function _print($imprime=false)
    {
      $texto=$this->nombre.' (';
      $nobjs=count($this->objs);
      for($j=0;$j<$nobjs;$j++)
	{
	  $texto.=$this->objs[$j];
	  if($j<$nobjs-1)
	    $texto.=',';
	}
      $texto.=')';
      if($this->id)
	$texto.=':'.$this->id;
      if($imprime)
	print $texto."\n";
      return $texto;
    }
  function xml(&$doc,&$nodo)
    {
      $rel=$doc->createElement('rel');
      $rel->setAttribute('name',$this->nombre);
      $rel=$nodo->appendChild($rel);
      foreach($this->objs as $k =>$arg)
	{
	  if(is_object($arg))
	    $arg->xml($doc,$rel);
	  else
	    {
	      $xarg=$doc->createElement('arg');
	      $tipo=$this->tipos[$k];
	      $xarg->setAttribute('type',$tipo);
	      if($tipo=='boolean')
		$xarg->setAttribute('value',$arg);
	      else
		$xarg->setAttribute('name',$arg);
	      $xarg=$rel->appendChild($xarg);
	    }
	}
    }
  function applyMap($mapeo,$yaocupados=array())
    { //Hay que revisar si no hay que mapear tambin el Id, se supone que no.
      $nombre=$mapeo->value($this->nombre);
      if(!$nombre)
	$nombre=$this->nombre;
      $this->nombre=$nombre;
      for($j=0;$j<count($this->objs);$j++)
	{
	  if(is_object($this->objs[$j])) //si es un objeto (poco probable)
	    $this->objs[$j]->applyMap($mapeo);
	  else //si slo es una referencia
	    {
	      $nvon=$mapeo->value($this->objs[$j]);
	      if(!$nvon)
		$nvon=$this->objs[$j];
	      $this->objs[$j]=$nvon;
	    }
	}
    }
}

/*     clase Accion           */
class Accion
{
  var $id;
  var $tipo;
  var $nombre;
  var $operador;
  var $isOper=false;
  var $args; //Objetos necesarios para llevar a cabo la accion: prerequisitos
  var $satisface=array(); //relaciones que satisface esta accin
  var $resuelve=array(); //objetos que resuelve esta accin
  var $from; //se usa para guardar el contexto en el que se aplica esta accion

  function Accion($tipo,$args,$nombre="",$operador="",$MemId=0)
    {
      $this->tipo=$tipo;
      $this->args=$args;
      $this->nombre=$nombre;
      $this->operador=$operador;
      $this->isOper=($operador != "")?true:false;
      if(is_object($MemId))
	$this->id=$MemId->getId($this);
      else
	$this->id=$MemId;
    }
  function clase()
    {
      return 'Accion';
    }
  function __clone()
    {
      foreach($this->satisface as $k =>$v)
	$this->satisface[$k]=clone $v;
    }
  function getId($mem)
    {
      return $this->id=$mem->getId($this);
    }
  function setId($id)
    {
      $this->id=$id;
    }
  function id() //devuelve el identificador de la accion en la memoria
    {
      return $this->id;
    }
  function tipo() //tipo del objeto a crear o draw para dibujar
    {
      return $this->tipo;
    }
  function nombre() //devuelve el nombre del objeto a crear o dibujar
    {
      return $this->nombre;
    }
  function args() //prerequisitos para llevar a cabo la accin
    {
      return $this->args;
    }
  function postcondicion($cont,$aplica=true)
    { //todavia falta ver lo de las relaciones satisfechas por la accin
      //que est en la memoria y las postcondiciones cuando la accin no
      //modifica el contexto
      // Cuando $aplica es falso unicamente se calcula el objeto que genera la accion
      $objeto='';
      $nombre=$this->nombre;
      if($this->tipo == 'draw' or $this->tipo == 'label')
	return null; //si laccin no modifica el contexto (por el momento no hacemos nada)
      $nargs=array();//nombres de los argumentos
      $targs=array();//tipos de los argumentos
      foreach($this->args as $arg)
	{
	  if(is_object($arg))//si el argumento es objeto
	    {
	      if($arg->clase()=='Accion') //de hecho debera ser otra accin
		{
		  $obj=$arg->postcondicion($cont,$aplica); //ejecutamos primero la accin para
		  //despues pasar el objeto resultante al contexto
		  if($obj)
		    {
		      //$argumentos[]=$obj;
		      $nargs[]=$obj->nombre();
		      $targs[]=$obj->tipo();
		    }
		}
	    }
	  else //si no es accin debe ser una referencia
	    {
	      $objref=$cont->getObjByName($arg);
	      if($objref)
		{
		  //$argumentos[]=$objref;
		  $nargs[]=$arg;
		  $targs[]=$objref->tipo();
		}
	      elseif($arg=='false' or $arg=='true')
		{//si es un booleano
		  $nargs[]=$arg;
		  $targs[]='boolean';
		}
	      else //si el objeto referenciado no existe en el contexto
		{
		  $nargs[]=$arg;
		  $targs[]='U'; //U de Unknown
		}
	    }
	}
      $nombreAnt=$nombre;
      if($nombre && $nombre !='_')
	{
	  $existe=$cont->getObjByName($nombre);
	  if($existe && ($existe->conocido() or $existe->tipo() != $this->tipo()))
	    $nombre=null;
	}
      if($nombre == '_') //si el objeto a crear es annimo
	$nombre=$cont->anonimo(); //obtenemos un nombre
      if($nombre == null) //si el objeto a crear no tiene nombre
	{
	  $nombre=$cont->nuevoNombre($this->tipo()); //obtenemos un nombre
	  $maptemp= new Mapeo();
	  $maptemp->map($nombreAnt,$nombre);
	  foreach($this->satisface as $sat)
	    $sat->applyMap($maptemp);
	  foreach($this->resuelve as $res)
	    if($res==$nombreAnt)
	      $res=$nombre;
	}
      if($this->isOper()) //si la accin crea un operador
	$objeto=new Operador($this->operador,$this->tipo,$nombre,$nargs,$targs);
      else //pero si crea un objeto
	$objeto=new ObjetoG($this->tipo,$nombre,$nargs,$targs);
      //print "Se agrega al contexto el objeto $nombre\n";
      if($aplica)
	{
	  //print "%%%estoy probando:\n";
	  //$this->_print(true);
	  //$cont->_print(true);
	  if($this->operador!='choose') //esto no sera mejor ponerlo en Reflection?
	    $cont->addConocido($objeto);
	  //$cont->_print(true);
	  foreach($this->satisface as $sat)
	    $cont->setSatisfecha($sat); 
	  //$cont->_print(true);
	  foreach($this->resuelve as $res)
	    $cont->setConocido($res);
	  //$cont->_print(true);
	  $this->nombre=$nombre;
	}
      return $objeto;
    }
  function operador()
    {
      return $this->operador;
    }
  function isOper()
    {
      return $this->isOper;
    }
  function comp($otra,&$mapeo)
    { //esta funcion se utiliza para comparar una accin leda de la experiencia previa con las acciones que estn en memoria. No tiene otro uso.
      $resultado=array();
      if($this->tipo() != $otra->tipo())
	return $resultado;
      $mapeo->map($this->nombre(),$otra->nombre()); //el primer elemento es la misma accin
      $targs=$this->args();
      $oargs=$otra->args();
      $nargs=count($targs);
      if($nargs != count($oargs))
	return $resultado;
      for($k=0; $k < $nargs; $k++)
	{
	  $targ=$targs[$k];
	  $oarg=$oargs[$k];
	  $tipotarg='string';
	  if(is_object($targ))
	    $tipotarg=$targ->clase();
	  $tipooarg='string';
	  if(is_object($oarg))
	    $tipooarg=$oarg->clase();
	  if($tipotarg != $tipooarg)
	    return $resultado; //si uno es texto y el otro es objeto
	  if($tipotarg == 'string')
	    { //si ambos son referencias, mapealos
	      $mapeo->map($targ,$oarg);
	    }
	  else //si ambos son acciones
	    {
	      $parcial=$targ->comp($oarg,$mapeo);
	      if(count($parcial)< 1)
		return $resultado;
	    }
	}
      //Ahora comparamos los objetos que resuelve
      $nres=count($this->resuelve);
      if($nres != count($otra->resuelve))
	return $resultado;
      $tres=$this->resuelve;
      $ores=$otra->resuelve;
      for($k=0;$k<$nres;$k++)
	{
	  if($mapeo->contieneLlave($tres[$k]))
	    {
	      if($mapeo->value($tres[$k])!=$ores[$k])
		return $resultado;
	    }
	  else
	    if(!$mapeo->contiene($ores[$k]))
	      $mapeo->map($tres[$k],$ores[$k]);
	}
      //finalmente comparamos las relaciones que satisface
      $nsat=count($this->satisface);
      if($nsat != count($otra->satisface))
	return $resultado;
      $cubetas=array();
      for($k=1;$k<=$nsat;$k++)
	$cubetas[$k]=array();
      foreach($this->satisface as $tsat)
	{
	  $posibles=$tsat->buscaEn($otra->satisface);
	  $cp=count($posibles);
	  if($cp == 0)
	    return $resultado;
	  $cubetas[$cp][]=array($tsat,$posibles);
	}
      for($k=1;$k<=$nsat;$k++)
	foreach($cubetas[$k] as $ec)
	  {
	    $sepudo=$ec[0]->buscaMapeo($ec[1],$mapeo);
	    if(!$sepudo)
	      return $resultado;
	  }

      $resultado['id']=$this->id;
      $resultado['mapeo']=$mapeo;
      return $resultado;
    }
  function comparaArgumentos($otra)
    {
      $resultado=true;
      if($this->tipo() != $otra->tipo())
	return false;
      $targs=$this->args();
      $oargs=$otra->args();
      $nargs=count($targs);
      if($nargs != count($oargs))
	return false;
      for($k=0; $k < $nargs; $k++)
	{
	  $targ=$targs[$k];
	  $oarg=$oargs[$k];
	  $tipotarg='string';
	  if(is_object($targ))
	    $tipotarg=$targ->clase();
	  $tipooarg='string';
	  if(is_object($oarg))
	    $tipooarg=$oarg->clase();
	  if($tipotarg != $tipooarg)
	    return false; //si uno es texto y el otro es objeto
	  if($tipotarg == 'string')
	    { //si ambos son referencias
	      if($targ!=$oarg)
		return false;
	    }
	  else //si ambos son acciones
	    {
	      $nt=$targ->nombre();
	      $no=$oarg->nombre();
	      if($nt != $no)
		return false;
	    }
	}
      return true;
    }
	
  function applyMap($mapeo,$forzado=0)
    {
      if(($forzado && $mapeo->value($this->nombre)) or !$forzado)
	$this->nombre=$mapeo->value($this->nombre);
      for($j=0;$j<count($this->args);$j++)
	{
	  $arg=$this->args[$j];
	  if(is_object($arg))//si el argumento es objeto
	    {
	      if($arg->clase()=='Accion') //de hecho debera ser otra accin
		{
		  $obj=$this->args[$j]->applyMap($mapeo,$forzado); //aplicamos el mapeo a la otra accin
		}
	    }
	  else //si no es accin debe ser una referencia
	    {
	      if(($forzado && $mapeo->value($arg)) or !$forzado)
		$this->args[$j]=$mapeo->value($arg);
	    }
	}
      for($j=0;$j<count($this->resuelve);$j++)
	if(($forzado && $mapeo->value($this->resuelve[$j])) or !$forzado)
	  $this->resuelve[$j]=$mapeo->value($this->resuelve[$j]);
      for($j=0;$j<count($this->satisface);$j++)
	for($k=0;$k<count($this->satisface[$j]->objs);$k++)
	  if(($forzado && $mapeo->value($this->satisface[$j]->objs[$k])) or !$forzado)
	    $this->satisface[$j]->objs[$k]=$mapeo->value($this->satisface[$j]->objs[$k]);
      if(!$forzado)
	$this->mapeo=$mapeo;
    }
  function satisface($rels=array())
    {
      if(is_array($rels))
	foreach($rels as $rel)
	  $this->satisface[]=clone $rel;
      else
	$this->satisface[]= clone $rels;
    }
  function resuelve($objs=array())
    {
      if(is_array($objs))
	{
	  foreach($objs as $obj)
	    if(!in_array($obj,$this->resuelve))
	      $this->resuelve[]=$obj;
	}
      else
	if(!in_array($objs,$this->resuelve))
	  $this->resuelve[]=$objs;
    }
  function _print($imprime=false)
    {
      $texto=$this->tipo.' '.$this->nombre.' (';
      $nargs=count($this->args);
      for($j=0;$j<$nargs;$j++)
	//foreach($this->args as $j=>$arg)
	{
	  $arg=$this->args[$j];
	  if(is_object($arg))//si el argumento es objeto
	    {
	      if($arg->clase()=='Accion') //de hecho debera ser otra accin
		$texto.=$arg->_print(); //imprimimos la otra accin
	    }
	  else //si no es accin debe ser una referencia
	    $texto.=$arg;
	  if($j < $nargs-1)
	    $texto.=', ';
	}
      $texto.=')';
      if($this->isOper())
	$texto.=' * '.$this->operador();
      if(count($this->resuelve))
	$texto.=' Resuelve: '.implode(',',$this->resuelve);
      if(count($this->satisface))
	foreach($this->satisface as $sat)
	  $texto.="\n\tSatisface:".$sat->_print();
      if($imprime)
	print $texto."\n";
      return $texto;
    }
  function xml(&$doc,&$nodo)
    {
      $objeto='';
      if($this->isOper())
	{
	  $objeto=$doc->createElement('op');
	  $objeto->setAttribute('oper',$this->operador);
	  $objeto->setAttribute('type',$this->tipo);
	}
      else
	$objeto=$doc->createElement($this->tipo);
      $objeto->setAttribute('name',$this->nombre);
      $objeto=$nodo->appendChild($objeto);
      foreach($this->args as $k =>$arg)
	{
	  if(is_object($arg))
	    $arg->xml($doc,$objeto);
	  else
	    {
	      $xarg=$doc->createElement('arg');
	      //$tipo=$this->tipos[$k];
	      //$xarg->setAttribute('type',$tipo);
	      if($arg=='false' or $arg=='true')
		{
		  $xarg->setAttribute('type','boolean');
		  $xarg->setAttribute('value',$arg);
		}
	      else
		$xarg->setAttribute('name',$arg);
	      $xarg=$objeto->appendChild($xarg);
	    }
	}
      foreach($this->resuelve as $r)
	{
	  $xres=$doc->createElement('res');
	  $xres->setAttribute('name',$r);
	  $xres=$objeto->appendChild($xres);
	}
      foreach($this->satisface as $sat)
	{
	  $xsat=$doc->createElement('sat');
	  $xsat=$objeto->appendChild($xsat);
	  $sat->xml($doc,$xsat);
	}
    }
  function set_from($Ct)
    {
      $this->from=$Ct;
    }
  function get_from()
    {
      return $this->from;
    }
}

/*     clase Solucion           */
class Solucion
{
  var $problema;
  var $pasos; //acciones
  function Solucion($problema,$pasos=array())
    {
      $this->problema=$problema;
      $this->pasos=$pasos;
    }
  function clase()
    {
      return 'Solucion';
    }
  function addPaso($paso)
    {
      array_push($this->pasos,$paso);
    }
  function getContexto()
    {
      return $this->problema;
    }
  function getPasos()
    {
      return $this->pasos;
    }
}

/*     clase OpNuevo               */
class OpNuevo
{
  var $nuevo; //operador nuevo
  var $idSolucion; //indice de la solucion en un arreglo de soluciones
  var $idOp;  //identificador rpido de este operador
  function OpNuevo($operador,$idx=null)
    {
      $this->nuevo=$operador;
      $this->idSolucion=$idx;
      $nop=$operador->nop();
      $tipos=$operador->tpreq();
      $idOp="$nop(".join(',',$tipos).')';
      $this->idOp=$idOp;
    }
  function setIdSol($idx)
    {
      $this->idSolucion=$idx;
    }
  function id()
    {
      return $this->idOp;
    }
  function oper()
    {
      return $this->nuevo;
    }
  function nop()
    {
      return $this->nuevo->nop();
    }
  function getIdSol()
    {
      return $this->idOp;
    }
  function xml(&$doc,&$nodo)
    {
      $xdef=$doc->createElement('define');
      $xdef=$nodo->appendChild($xdef);
      $this->nuevo->xml($doc,$xdef);
    }
}

/*               Clase Mapeo                          */
class Mapeo
{
  var $mapeo=array();

  function Mapeo()
    {
      $nargs=func_num_args();
      if($nargs==1)
	{
	  $arg=func_get_arg(0);
	  $clase=$arg->clase();
	  if($clase == 'Contexto')
	    { //Mapeo identidad a partir de un contexto
	      $this->ident($arg->getDesconocidos());
	      $this->ident($arg->getConocidos());
	    }
	  else //Mapeo identidad a partir de una accin
	    $this->ident($arg);
	}
      if($nargs==2)
	{ //mapear 2 contextos?
	}
    }
  function ident($argumento)
    {
      if(is_array($argumento)) //una lista de objetos
	{//Mapea identicamente los nombres de los objetos en los objetos y en las relaciones
	  foreach($argumento as $obj)
	    {
	      $this->ident($obj);
	    }
	}
      elseif(is_object($argumento))
	{
	  if($argumento->clase() == 'Accion')
	    { //Mapea identicamente los nombres de los elementos
	      $nombre=$argumento->nombre();
	      if($nombre != '' and $nombre != '_')
		$this->map($nombre,$nombre);
	      $argumentos=$argumento->args();
	      foreach($argumentos as $arg)
		{
		  $tipoarg='string';
		  if(is_object($arg))
		    $tipoarg=$arg->clase();
		  if($tipoarg =='string') //si es una referencia
		    $this->map($arg,$arg); //mapeamos la referencia
		  if($tipoarg =='Accion') //pero si es otra accin
		    $this->ident($arg); //aplicamos este mtodo recursivamente.
		}
	      $resuelve=$argumento->resuelve;
	      foreach($resuelve as $r)
		{
		  if(!$this->contiene($r))
		    $this->map($r,$r);
		}
	      $satisface=$argumento->satisface;
	      foreach($satisface as $s)
		{
		  $objs=$s->interv();
		  foreach($objs as $o)
		    if(!$this->contiene($o))
		      $this->map($o,$o);
		}
	    }
	  if($argumento->clase() == 'ObjetoG' or $argumento->clase() == 'Operador')
	    {
	      $nombre=$argumento->nombre();
	      if($nombre != '' and $nombre != '_')
		$this->map($nombre,$nombre);
	      $argumentos=$argumento->args();
	      foreach($argumentos as $arg)
		{ //para cada argumento aplicamos este mtodo recursivamente
		  $this->ident($arg);
		}					
	    }
	}
      else
	{
	  if($argumento != '' and $argumento != '_')
	    $this->map($argumento,$argumento);
	}
    }

  function map($llave,$valor)
    { //aqui habra que ver si no existe esa llave
      $this->mapeo[$llave]=$valor;
    }
  function keys()
    {
      return array_keys($this->mapeo);
    }
  function value($llave)
    {
      return $this->mapeo[$llave];
    }
  function contieneLlave($llave)
    {
      return isset($this->mapeo[$llave]);
    }
  function contiene($valor)
    {
      return in_array($valor,$this->mapeo);
    }
  function post($otro)
    {// Devuelve el resultado de componer este mapeo despus de otro mapeo
      $resultado=new Mapeo();
      /*print_r($otro);
			print "---\n";*/
      $llaves=$otro->keys();
      foreach($llaves as $llave)
	{
	  $intermedio=$otro->value($llave);
	  if($this->contieneLlave($intermedio))
	    $resultado->map($llave,$this->value($intermedio));
	  else
	    if($this->contiene($intermedio))
	      $resultado->map($llave,null);
	    else
	      $resultado->map($llave,$intermedio);
	}
      return $resultado;
    }
  function reverse()
    { //devuelve el mapeo inverso
      $resultado=new Mapeo();
      foreach($this->keys() as $llave)
	$resultado->map($this->value($llave),$llave);
      return $resultado;
    }
  function add($otro)
    { //agrega otro mapeo a este mapeo
      foreach($otro->keys() as $llave)
	{
	  $this->map($llave,$otro->value($llave));
	}
    }
  function size()
    {
      return count($this->mapeo);
    }
  function _print($imprime=false)
    {
      $texto='[';
      $keys=$this->keys();
      $nk=count($keys);
      for($j=0;$j<$nk;$j++)
	{
	  $k=$keys[$j];
	  $v=$this->value($k);
	  $texto.="$k>$v";
	  if($j<$nk-1)
	    $texto.=' ';
	}
      $texto.="]\n";
      if($imprime)
	print $texto;
      return $texto;
    }
}
?>