<?
/********************************************************
 *                                                      *
 *                   Proceso Central                    *
 *                                                      *
 ********************************************************/

require_once('Memoria.php');
require_once('Engagement.php');
require_once('parametros.php');
require_once('Reflection.php');

$parada=0;

function leeProblemasDeArchivo($arch)
{
	//print "Lee problemas\n";
	$problemas=array();
	$doc= new domDocument();
	$doc->load($arch);
	$root=$doc->documentElement;
	$mtemp=new Memoria();
	foreach($root->getElementsByTagName('problema') as $probx) //para cada problema en el archivo
		{
			$contexto=$mtemp->getContexto($probx->getElementsByTagName('contexto')->item(0)); //extraemos el problema
			$define=$probx->getElementsByTagName('define')->item(0);
			if($define)
				{
					$define=$mtemp->getDefine($define); //extraemos el operador que define
				}
			$problemas[]=array('contexto'=>$contexto,'define'=>$define);
		}
	return $problemas;
}

function resuelve($problema,$mem,$reporta=false)
{
	$Historia=new Historia();
	$errores=array();
	return resuelveRec($problema,$mem,$reporta,$Historia,$errores);
}

function resuelveRec($problema,$mem,$reporta,$Historia,&$errores)
{
	global $pasos_engagement;
	$unsolved=true;
	$try=true;
	//$solucion=array();//voy a meter esto en historia
	while($unsolved && $try)
		{
			//probablemente necesitemos una pila para poder regresar. (busqueda en profundidad)
			$pasos=array();
			$impasse=false;
			$copiaProblema=clone $problema;
			$copiaHistoria=clone $Historia;
			for($i=0;$i < $pasos_engagement && !$impasse; $i++)
				{
					$parada++;
					$impasse=Engagement($copiaProblema,$mem,$pasos,$copiaHistoria);
					if($impasse)
						print ">>> IMPASSE\n";
				}
			$parada++;
			$unsolved=Reflection($problema,$mem,$pasos,$Historia,$reporta,$impasse,$errores);
			print ($unsolved)?"Sin Resolver\n":"Resuelto\n";
			//if($unsolved && $impasse) //para terminar programa si no se puede resolver
			if(count($errores))
				{
					$try=false;
					print_r($errores);
				}
		}
	if(!$try)
		return array();
	return $Historia->solucion();
}

class Historia
{//clase para almacenar la historia de solucin de un problema, en particular guarda las acciones que ya fueron aplicadas para no repetirlas.
	var $contextos=array(); //lista de los contextos en el problema actual
	var $intentados=array(); //pasos intentados
	var $solucion=array();
	var $pasoNo;  //numero de pasos
	function Historia()
		{
			$pasosNo=0;
		}
	function nuevoPaso()
		{
			$pasosNo++;
			return $pasosNo;
		}
	function intentados($contexto)
		{
			$id=array_search($contexto,$this->contextos);
			if($id !== false)
				return $this->intentados[$id];
			return array();
		}
	function addPaso($contexto,$paso,$gen='E')
		{
			$id=array_search($contexto,$this->contextos);
			if($id !== false)
				array_push($this->intentados[$id],array($paso,$gen,$this->nuevoPaso()));
			else
				{
					$this->contextos[]=$contexto;
					$this->intentados[]=array(array($paso,$gen,$this->nuevoPaso()));
				}
		}
	function reduceAcciones($contexto,$lista)
		{
			$resultado=array();
			//Primero descartamos las acciones que ya se aplicaron en el pasado con este contexto
			$id=array_search($contexto,$this->contextos);
			if($id ==false)
				$intentados=array();
			else
				$intentados=$this->intentados[$id];
			if(count($intentados))
				{
					$cuantas=count($lista);
					for($p=0;$p<$cuantas;$p++)
						{
							if(in_array($lista[$p][0],$intentados))
								unset($lista[$p]);
						}
				}
			//descartamos las acciones que omiten argumentos
			foreach($lista as $k=>$acc)
				{
					foreach($acc[0]->args() as $arg)
						if(is_null($arg))
							{
								unset($lista[$k]);
								break;
							}
				}
			//despus descartamos las acciones que ya estn aplicadas.
			$anteriores=$contexto->getConocidos();
			foreach($lista as $acc)
				{
					$acc[0]->_print(true);
					if(!$this->existeEnSol($acc[0]))
					  //aqui necesito comparar los argumentos de la accin sin tomar en cuenta el nombre del nuevo objeto.
						$resultado[]=$acc;
				}
			return $resultado;
		}
	function solucion()
		{
			return $this->solucion;
		}
	function addToSol($accion)
		{
			$this->solucion[]=$accion;
		}
	function existeEnSol($accion)
		{
			foreach($this->solucion as $paso)
				{
					if($paso->comparaArgumentos($accion))
						return true;
				}
			return false;
		}
	function chgSolucion($newsol)
		{ //funcin para cambiar la solucin (cuando es resumida)
			$this->solucion=$newsol;
		}
}
?>