<?
/********************************************************
 *                                                      *
 *                     Reflection                       *
 *                                                      *
 ********************************************************/
function Reflection(&$problema,&$mem,&$pasos,&$historia,$reporta,&$impasse,&$errores)
{
  print "--- Reflection\n";
  //$problema->_print(true);
  //print "--\n";
  $resuelto=false;
  $imposible=false;
  foreach($pasos as $paso)
    {
      $Ct=$paso->get_from(); //obtenemos el contexto que est asociado con esta accin en la LTM
      //checar si se cumplen los prerrequisitos del paso
      //si no se cumplen los prerrequisitos crear las acciones necesarias o un problema nuevo para crear dichos prerrequisitos
      $prerreq=$paso->args();
      $faltan=array();
      $insertoPasos=false;
      foreach($prerreq as $pr)
				{
					$obj=$problema->getObjByName($pr,0); // sospecho que puede ocurrir que por error el paso tenga un argumento con un nombre que si existe en el problema
					if($pr!='true' && $pr!='false')
						{
							//if(!$pr)
							//break 2;
							if(!$obj)
								$faltan[]=$pr;
							else //si existe el prerrequisito
								{//pero es de un tipo incorrecto
									//$obj->_print(true);
									$objfLTM=$Ct->getObjByName($pr);
									//print "$pr\n";
									//$Ct->_print(true);
									if(!$objfLTM)
										break;
									if($obj->tipo() != $objfLTM->tipo())
										{ //le damos un nuevo nombre
											$nuevo=$problema->nuevoNombre($objfLTM->tipo());
											$nmap=new Mapeo();
											$nmap->map($pr,$nuevo);
											$Ct->applyMap($nmap);
											$paso->applyMap($nmap,1);
											$faltan[]=$nuevo;
										}
								}
						}
				}
      //print "Prerrequisitos: \n";
      //print_r($prerreq);
      //print "Faltan \n";
      //print_r($faltan);
      //en $faltan estn los nombres de los objetos que no existen, pero para saber cmo son esos objetos debo revisar cmo son esos objetos en el contexto en LTM
      if(count($faltan)>0)
				{
					$satEnCt=$Ct->getSatisfechas(); //lista de relaciones satisfechas en el contexto CT de LTM
					//Ahora busquemos cada uno de los faltantes en el contexto.
					$orden=new orden(); //objeto para generar un orden parcial
					foreach($faltan as $f)
						{//por cada prerrequisito faltante
							$orden->add($f); //se agrega al orden parcial.
							$PF=array(); //lista de prerrequisitos faltantes que requieren una revisin ms profunda
							$PN=array(); //lista de prerrequisitos faltantes que requieren resolver un problema nuevo
							$objf=$Ct->getObjByName($f,0);// busca el faltante entre los conocidos.
							if($objf)
								{
									//si se encuentra el objeto, vamos a revisar que existan sus prerrequisitos y a buscar las relaciones en que participa
									//tenemos varios casos:
									//el ms sencillo es que este objeto no tenga prerrequisitos, en cuyo caso podemos generar la accin para crear este objeto faltante a menos que el objeto tenga que satisfacer relaciones con otros objetos (desconocidos?).
									//que todos los prerrequisitos de este objeto sean conocidos en el contexto del problema actual, para lo cual hay 2 casos:
									//si no hay relaciones que satisfacer podemos generar la accin para crear el objeto faltante
									//pero si hay relaciones que satisfacer podemos optar por generar la accin diciendo qu relacion se satisface o generar un problema nuevo, el problema con la primera opcin es que no podemos saber si se necesita hacer ms cosas para satisfacer la relacin
									
									//que algunos de los prerrequisitos de este objeto sean desconocidos en el contexto actual, aqu puede ser que algunos de esos desconocidos tambin estn en la lista de faltantes o no.
									//el primer caso podemos evitarlo ordenando los objetos faltantes segun quin depende de quin.
									//en el caso en que algunos prerrequisitos de este objeto faltante sean desconocidos en el contexto actual y ninguno sea tambin faltante podemos realizar una revisin ms profunda en algunos casos de forma recursiva.

									//Entonces vamos a hacer dos revisiones, una para ver si este prerrequisito requiere otros prerrequisitos y otra para ver si el faltante debe satisfacer relaciones o no, es decir, si  debemos crear un problema nuevo o si podemos crear la accin.
									$argsf=$objf->args(); //esta es la lista de objetos prerrequisitos del objeto faltante. Necesitamos ver si estos objetos son conocidos en el contexto del problema actual o entre los mismos faltantes.
									foreach($argsf as $af)
										{
											$objaf=$problema->getObjByName($af,0);
											$noConocido=false;
											if($objaf)
												{
													$objafLTM=$Ct->getObjByName($af,0);
													if($objaf->tipo() !== $objafLTM->tipo())
														$noConocido=true;
												}
											else
												$noConocido=true;
											if($noConocido)
												{//si no es conocido en nuestro problema
													//y est en la lista de faltantes entonces debemos resolver este prerrequisito antes de resolver el faltante.
													//$Ndesc++;
													if(in_array($af,$faltan))
														{
															$orden->lt($af,$f);//asignamos el orden de resolucin
														}
													else
														//pero si el prerrequisito no es faltante entonces este faltante requiere una revisin ms profunda.
														{
															if(!in_array($f,$PF))
																$PF[]=$f; //guardamos el objeto faltante actual en una lista para revisarlo ms profundamente
														}
												}
										}
									//buscamos si este objeto faltante satisface alguna relacin en el contexto de LTM
									$satisface=array();
									//$todosConocidos=true;
									foreach($satEnCt as $PSt)
										{//buscamos en cada relacion satisfecha del contexto
											$relacionados=$PSt->RelacionaA($objf);
											//si este objeto faltante tiene que satisfacer relaciones
											if(count($relacionados))
												{
													if(!in_array($f,$PN))
														$PN[]=$f;
													break;
												}
										}
								}
							else
								{
									//pero si el objeto faltante no se encuentra en el contexto en LTM probablemente estemos en un aprieto
									
									$imposible=true;
									$errores[]="El objeto faltante $f no existe en el Contexto en Memoria";
								}
						}
					$faltanNuevo=$orden->ordenados(); //lista de faltantes en el orden en que deben resolverse
					//esta lista ya est ordenada as que en principio solo debemos preocuparnos por 3 casos:
					//si el faltante est en la lista de problemas nuevos entonces creamos un problema nuevo
					//si el faltante no est entre los problemas nuevos, pero est entre los que requieren una revisin ms profunda entonces aplicamos reflection recursivamente
					//si el faltante no satisface ninguna relacin entonces simplemente lo creamos
					//print "Faltan Ordenado\n";
					//print_r($faltanNuevo);
					foreach($faltanNuevo as $f)
						{//para cada faltante
							//checamos que en realidad siga faltando
							$existe=$problema->getObjByName($f,0);
							if(!$existe)
								{//si sigue siendo un faltante
									$objf=$Ct->getObjByName($f,0);// busca el faltante entre los conocidos del contexto en LTM
									print "Falta $f en el paso:\n";
									$paso->_print(true);
									$Ct->_print(true);
									$argsf=$objf->args();
									if(in_array($f,$PN))
										{
											//primero vamos a ver si las unicas relaciones que debe satisfacer son del tipo que algo est en el nuevo objeto y que sus prerrequisitos existan
											$relaciones=array();
											$solubles=true;
											foreach($satEnCt as $PSt)
												{//buscamos en cada relacion satisfecha del contexto
													$relacionados=$PSt->RelacionaA($objf);
													//si este objeto faltante tiene que satisfacer relaciones
													if(count($relacionados))
														{
															$interv=$PSt->interv();
															if($PSt->nombre()=='on' && $interv[1]==$f)
																{
																	$relaciones[]=clone $PSt;
																}
															else
																{
																	$solubles=false;
																	break;
																}
														}
												}
											$preqs=true;
											foreach($argsf as $af)
												{
													$objaf=$problema->getObjByName($af,0);
													if(!$objaf)
														{
															$preqs=false;
															break;
														}
												}
											$solpn=array();
											if($solubles)
												{//si las relaciones no son problema
													$nuevaAcc=new Accion($objf->tipo(),$argsf,$f,$objf->nop());
													$nuevaAcc->satisface($relaciones);
													$nuevaAcc->set_from($Ct);
													if($preqs) //y adems los prerrequisitos estn satisfechos
														$solpn[]=$nuevaAcc;
													else
														{//si el problema son los prerrequisitos
															print "Reflection Recursivo 2: \n";
															print "  Accin Nueva: \n";
															$nuevaAcc->_print(true);
															$tmp=array($nuevaAcc);
															Reflection($problema,$mem,$tmp,$historia,$reporta,$impasse,$errs);
															if(count($errs))
																{
																	$imposible=true;
																	$errores=array_merge($errores,$errs);
																}
															else
																$insertoPasos=true;
														}
														
												}
											else
												{
													print "Problema Nuevo: $f\n";
													$idxn=array_search($f,$PN);
													$probNvo=$problema->ProbNvo($f,$Ct); //esta funcin va a estar complicada
													$errs=array();
													if($probNvo) //solo si este problema realmente fue necesario
														{
															$solpn=resuelveRec($probNvo,$mem,$reporta,clone $historia,$errs); //aqui podemos usar la misma $historia ?
														}
													if(count($errs))
														{
															$imposible=true;
															$errores=array_merge($errores,$errs);
														}
												}
											foreach($solpn as $ppn)
												{
													$historia->addPaso($problema,array($ppn),'R');
													$historia->addToSol($ppn);
													$ppn->postcondicion($problema);
													$insertoPasos=true;
												}
											unset($PN[$idxn]);
											if(in_array($f,$PF))
												{
													$idxf=array_search($f,$PF);
													unset($PF[$idxf]);
												}
											continue;
										}
									if(in_array($f,$PF))
										{//si es necesario revisar profundamente.

											$idxf=array_search($f,$PF);

											$errs=array();
											//antes es necesario reevaluar si hace falta revisar nuevamente, es decir, capaz que los prerrequisitos de este faltante ya existen.
											$objf=$Ct->getObjByName($f,0);
											$argsf=$objf->args(); //esta es la lista de objetos prerrequisitos del objeto faltante. Necesitamos ver si estos objetos son conocidos en el contexto del problema actual.
											$necesarioRevisar=false;
											foreach($argsf as $af)
												{
													$objaf=$problema->getObjByName($af,0);
													if($objaf)
														{
															$objafLTM=$Ct->getObjByName($af,0);
															if($objaf->tipo() !== $objafLTM->tipo())
																{
																	$necesarioRevisar=true;
																	break;
																}
														}
													else
														$necesarioRevisar=true;
												}
											if($necesarioRevisar)
												{
													$nuevaAcc=new Accion($objf->tipo(),$argsf,$f,$objf->nop());
													$nuevaAcc->set_from($Ct);
													print "Reflection Recursivo: ";
													$nuevaAcc->_print(true);
													$tmp=array($nuevaAcc);
													Reflection($problema,$mem,$tmp,$historia,$reporta,$impasse,$errs);
													if(count($errs))
														{
															$imposible=true;
															$errores=array_merge($errores,$errs);
														}
													else
														$insertoPasos=true;
													unset($PF[$idxf]);
													continue;
												}
											else
												unset($PF[$idxf]);
										}
									//else
									//{
									//si no es necesario crear un problema nuevo
									//entonces en teoria este faltante no tiene prerrequisitos o ya estn satisfechos y adems este objeto no satisface relaciones. Ahora podemos crear la accin y aplicarla
									$nuevaAcc=new Accion($objf->tipo(),$argsf,$f,$objf->nop());
									$historia->addPaso($problema,array($nuevaAcc),'R');
									$historia->addToSol($nuevaAcc);
									print "Arregla faltante $f:\n";
									$nuevaAcc->_print(true);
									$nuevaAcc->postcondicion($problema);
									$insertoPasos=true;
								}
						}
				}
      //si el paso no tiene prerrequisitos o ya existen todos, podemos aplicarlo
      //print "Imposible:$imposible|\n";
      if(!$imposible)
				{
					//print "Aplica Paso:\n";
					//$paso->_print(true);
					AplicaPaso($problema,$paso,$historia);
					//esta funcion va a revisar si el contexto y la solucion se pueden resumir
					//tambin va a revisar si el paso satisface alguna relacin no considerada.
					if(Resuelto($problema))
						break;
					if($insertoPasos)
						{
							$impasse=false;
							break;
						}
				}
    }
  //Antes de revisar si hay un impasse veamos si el problema ha sido resuelto, en cuyo caso hacemos una ltima revisin.

  $resuelto=Resuelto($problema);
	
  //Aqui podemos evaluar cmo vamos avanzando y si parece que no avanzamos tratar de hacer algo.
  //Aqu tambin podemos checar si las relaciones satisfechas pueden implicar una accin nueva.
	
	print "Impasse:$impasse|Resuelto:$resuelto|\n";
  if($impasse && !$resuelto)
    {
			print "Intenta resolver impasse\n";
      //si hay un impasse vamos a tratar de resolverlo
      //un impasse ocurre cuando engagement no encuentra acciones
      //puede deberse a que hace falta una accin que construye un objeto buscado, es decir,si este objeto ya no tiene relaciones por satisfacer y si sus prerrequisitos ya estn satisfechos.
      //para cada desconocido vamos a ver si tiene relaciones por satisfacer o prerrequisitos sin resolver.
      $huboCambios=ResuelveUnDesconocido($problema,$historia,$errores);
			print "Intenta un Desconocido\n";
      if($huboCambios)
				$resuelto=Resuelto($problema);
      else
				{// si no entonces tratamos de resumir las acciones o relaciones on para formar intersecciones
					$huboCambios=ResumeOn($problema,$historia,$errores);
					print "Intenta un Resumir\n";
					if($huboCambios)
						$resuelto=Resuelto($problema);
					else
						{//si no hubo cambios entonces vamos a ver si hay alguna relacin que se pueda transformar en accin
							$huboCambios=Rel2Op($problema,$historia,$errores);
							print "Intenta un Operador por Relacin\n";
							if($huboCambios)
								$resuelto=Resuelto($problema);
						}
				}
      //si podemos descubrir nuevas relaciones entre los objetos existentes. pero esto genera 2 problemas, uno es cmo hacer este descubrimiento y el otro es cmo saber si una relacin descubierta es relevante para nuestro problema. Aunque podramos guiarnos por las relaciones que no se han resuelto.
      //otra opcin puede ser buscar por uno de los objetos desconocidos entre los problemas en la experiencia previa y ver qu objetos del problema original no estn en nuestro problema para ver si creando dichos objetos se puede continuar la solucin.
      //hasta ahorita no ha ocurrido y no lo he hecho.
      if(!$huboCambios)
				$errores[]='Reflection no encuentra una salida';
    }
  if($resuelto)//si ya esta resuelto hacemos un resumen
    ResumeOn($problema,$historia,$errores);
  /*
	print "Solucin hasta este punto:\n";
	foreach($historia->solucion() as $p)
		{
			$p->_print(true);
		}
  */
  print "Sale de Reflection\n";
  return !$resuelto;
}
//AQUI
// Quiero generalizar el uso del objeto solucion para poder llevar un control de como se van agregando las acciones, cuando se borran, etc.

//YA: adems tengo que hacer el metodo para crear nuevos problemas o por lo menos darle la vuelta al caso que tengo ahorita.

//tengo que pensar como resolver el problema que surge cuando los problemas son simetricos y solo tengo una de las soluciones. A lo mejor puedo cambiar los nombres de los objetos en la simetria cuando sea necesario.

//Esto va primero: tengo que hacer el catlogo de operadores que resuelven relaciones.

function Resuelto(&$problema)
{
  //bsicamente el problema est resuelto si ya no hay objetos desconocidos (y relaciones insatisfechas).
  //si ya no hay objetos desconocidos revisamos que efectivamente hemos construido los objetos desconocidos en el problema original y que efectivamente todas las relaciones insatisfechas en el problema original han sido satisfechas.
  //si ya no hay objetos desconocidos, pero si relaciones insatisfechas deberamos de poder revisar qu falta para satisfacer dichas relaciones
  //por lo pronto nos bastar ver si hay desconocidos o no.
  $res=false;
  $desc=$problema->getDesconocidos();
  $ins=$problema->getInsatisfechas();
  if(!count($desc))
    {
      $res=true;
      //por ahora simplemente pasamos las insatisfechas a las satisfechas
      foreach($problema->getInsatisfechas() as $Insat)
				$problema->setSatisfecha($Insat);
    }
  return $res;
}

function AplicaPaso(&$problema,&$paso,&$historia)
{					//esta funcion va a revisar si el contexto y la solucion se pueden resumir
					//tambin va a revisar si el paso satisface alguna relacin no considerada.
  //El primer caso que quiero y puedo resumir es el de un objeto que pertenece a otros, de manera que puedo reducir las acciones de operador CHOOSE e INTERSECTION de un objeto en un solo INTERSECTION: como ocasionaba problemas lo cambie de lugar
  $op=$paso->operador();
  $nombre=$paso->nombre();
  $tipo=$paso->tipo();
  $args=$paso->args();
  $objex=$problema->getObjByName($nombre,0); //veamos si el resultado de aplicar esta accin ya existe o no.
  if($objex)
    return;
  //Tambin es deseable revisar aqui si realmente satisface las que dice satisfacer.
  $historia->addPaso($problema,array($paso));
  $historia->addToSol($paso);
  $paso->postcondicion($problema);
}

function ResuelveUnDesconocido(&$problema,&$historia)
{//esta funcin busca si existe algn desconocido sin prerrequisitos por resolver y sin relaciones por satisfacer
  //en cuyo caso crea una accin y la aplica para resolver el desconocido
  //solo se usa en caso de impasse
  $desc=$problema->getDesconocidos();//obtenemos la lista de desconocidos
  //primero buscamos si no tienen prerrequisitos sin resolver
  $sinPR=array();
  $candidatos=array();
  $cambios=false;
  foreach($desc as $d)
    {
      $sPR=true;
      $P=$d->args();
      //para cada prerrequisito de este problema
      foreach($P as $preq)
				{//buscamos el prerrequisito entre los conocidos
					$obj=$problema->getObjByName($preq,0);
					//si no est entonces ya no seguimos revisando este desconocido
					if(!$obj)
						{
							$sPR=false;
							break;
						}
				}
      if($sPR)
				$sinPR[]=$d;
    }
  //ahora de los que no tienen prerrequisitos por resolver
  //buscamos si tienen relaciones por satisfacer.
  $Ins=$problema->getInsatisfechas();
  $libres=array();
  foreach($sinPR as $d)
    {
      $libre=true;
      $relaciones=array();
      foreach($Ins as $rel)
				{//para cada insatisfecha
					if($rel->relacionaA($d))
						{//si relaciona al objeto
							$libre=false;
							$relaciones[]=$rel;
							//break;
						}
				}
      if($libre) //si ya no tiene relaciones por satisfacer
				$libres[]=$d;
      else
				{//si tiene relaciones por satisfacer
					//probablemente estas relaciones sean triviales de resolver.
				}
    }
  foreach($libres as $listo)
    {
      $nvoPaso=new Accion($listo->tipo(),$listo->args(),$listo->nombre(),$listo->nop());
      AplicaPaso($problema,$nvoPaso,$historia);
      //$nvoPaso->postcondicion($problema);
      $cambios=true;
    }
  return $cambios;
}

function ResumeOn(&$problema,&$historia,&$errores)
{//Esta funcion va a buscar en la solucin las relaciones On satisfechas y las acciones choose e intersection para resumirlas o tratar de agregar una accin choose o intersection cuando haga falta.
  $pasosNuevos=array();
  $On=array();
  $pasosOn=array();
  $pasos=$historia->solucion();
  foreach($pasos as $idx=>$paso)
    {
      $pop=$paso->operador();
      $pnombre=$paso->nombre();
      $pargs=$paso->args();
      if($pop=='choose' or $pop=='intersection' )
				{//si el paso previo dice explcitamente que este objeto pertenece a otros
					//vamos a marcar este paso guardandolo en los dos arreglos $On y $pasosOn
					if(array_key_exists($pnombre,$On))
						$On[$pnombre]=array_unique(array_merge($On[$pnombre],$pargs));
					else
						$On[$pnombre]=$pargs;
					if(array_key_exists($pnombre,$pasosOn))
						$pasosOn[$pnombre]=array_unique(array_merge($pasosOn[$pnombre],array($idx)));
					else
						$pasosOn[$pnombre]=array($idx);
				}
      else
				{// si el paso previo no dice nada explicitamente, pero si satisface la relacin que dice que nuestro objeto pertenece a otro
					foreach($paso->satisface as $satp)
						if($satp->nombre()=='on')
							{
								$interv=$satp->interv();
								$nombre=array_shift($interv);
								if(array_key_exists($nombre,$On))
									$On[$nombre]=array_unique(array_merge($On[$nombre],$interv));
								else
									$On[$nombre]=$interv;
							}
				}
    }
  //En $On tenemos todas las relaciones on, ahora vamos a revisar cada una:
  //Si ya existe un paso choose o intesection que indique completamente esta relacin lo dejamos como est,
  //Si existe un paso choose o intersection que indique parcialmente esta relacin, lo usamos para agregar un paso intersection y lo borramos.
  //Si no existe un paso choose o intersection, pero se puede crear una interseccion la creamos.
  foreach($On as $nobj=>$nargs)
    {// para cada objeto en otros
      $obj=$problema->getObjByName($nobj);
      $tipo=$obj->tipo();
      if(array_key_exists($nobj,$pasosOn))
				{//si existen pasos choose o intersection para este objeto
					$idxs=$pasosOn[$nobj];
					if(count($idxs)==1)
						{//si es un solo paso
							$paso=$pasos[$idxs[0]];
							$eargs=$paso->args();
							$dif=array_diff($nargs,$eargs);
							if(!count($dif)) //si el paso lo indica completamente
								continue; //saltamos esta relacion
						}
					$nres=array();
					$nsat=array();
					foreach($idxs as $idx)
						{//vamos a tomar las acciones para crear una nueva.
							$paso=$pasos[$idx];
							$nres=array_merge($paso->resuelve,$nres);
							$nsat=array_merge($paso->satisface,$nsat);
							unset($historia->solucion[$idx]);
						}
					//Ahora se borran las Acciones que crean al objeto sin prerrequisitos:
					foreach($pasos as $nidx=>$npaso)
						{
							$pop=$npaso->operador();
							$pnombre=$npaso->nombre();
							$pargs=$npaso->args();
							if($pnombre==$nobj && count($pargs)==0)
								{
									$problema->setDesconocido($nobj);
									unset($historia->solucion[$nidx]);
									break;
								}
						}
					//Finalmente se crea la Accin
					$npaso=new Accion($tipo,$nargs,$nobj,'intersection');
					$npaso->satisface($nsat);
					$npaso->resuelve($nres);
					$pasosNuevos[]=$npaso;
				}
      else
				{ //si no existen pasos choose o intersection
					if(count($nargs)>1)
						{ //si se puede crear una interseccion
							$npaso=new Accion($tipo,$nargs,$nobj,'intersection');
							$pasosNuevos[]=$npaso;
						}
				}
    }
  foreach($pasosNuevos as $idx=>$paso)
    {
      //luego revisamos si la accin puede satisfacer ms relaciones (del problema) de las que ya estn declaradas,
      //primero hacemos una lista con las relaciones insatisfechas que involucran a este objeto
      $misInsatisfechas=array();
      $insatisfechas=0;
      foreach($problema->getInsatisfechas() as $relI)
				{//para cada relacin insatisfecha
					$insatisfechas++;
					if(count($relI->relacionaA($nombre)))
						{//si relaciona al objeto de la accin
							$insat=true;
							foreach($nsat as $sat)
								{//vemos que la relacion no est entre las que satisface esta accin
									if($sat->equal($relI))
										{
											$insat=false;
											break;
										}
								}
							if($insat) //y si no est entre las que satisface esta accin la apartamos.
								$misInsatisfechas[]=clone $relI;
							else
								$insatisfechas--;
						}
				}
      foreach($misInsatisfechas as $idx=>$ins)
				{//revisamos cada una de las apartadas para ver si ya tenemos todo para satisfacerla
					//en ese caso se las anexamos a la accin
					if($ins->nombre()=='distinct')
						if($insatisfechas==1)
							{
								$paso->satisface($ins);
								unset($misInsatisfechas[$idx]);
							}
				}
      //despus revisamos si el objeto principal todava tiene relaciones por satisfacer
      //si ese fuera el caso entonces no hacemos nada ms que aplicar esta accin
      //si el objeto principal ya no tiene ms relaciones por satisfacer entonces en la accin marcamos que resuelve este objeto.
      if(!count($misInsatisfechas))
				$paso->resuelve($nombre);
      $problema->setDesconocido($nombre);
      AplicaPaso($problema,$paso,$historia);
    }
  return count($pasosNuevos);
}

function Rel2Op(&$problema,&$historia,&$errores)
{//esta funcin busca en el problema relaciones insatisfechas que se puedan resolver con un operador
  //las relaciones que se pueden intentar cambiar por operadores estn en el arrego $rel2op
  global $rel2op,$LTM;
  $insatisfechas=$problema->getInsatisfechas();
  foreach($insatisfechas as $ins)
    {
      $ins->_print(true);
      $nombre=$ins->nombre();
      print "$nombre: \n";
      //print_r($rel2op);
      if(array_key_exists($nombre,$rel2op))
				{//si esta en el catalogo de relaciones y operadores
					$nop=$rel2op[$nombre];
					$args=$ins->interv();
					$name=array_shift($args);
					$tipos=$ins->tobjs();
					$tipo=array_shift($tipos);
					$relid="$nop(".join(',',$tipos).')';
					print "Relacion: $relid\n";
					if(array_key_exists($relid,$LTM->definiciones) or $nop =='choose')
						{//si otro problema ya definio la operacion
							//ahora revisamos que los prerrequisitos para esta operacion
							//esten satisfechos
							$ok=true;
							foreach($args as $arg)
								{
									$con=$problema->getObjByName($arg,0);
									if(!$con)
										{
											$ok=false;
											break;
										}
								}
							if($ok)
								{//si ya no hay ningun impedimento
									print "new Accion($tipo,$args,$name,$nop)\n";
									$npaso=new Accion($tipo,$args,$name,$nop);
									$npaso->satisface($ins);
									AplicaPaso($problema,$npaso,$historia);
									return true;
								}
						}
				}
    }
  return false;
}

class orden
{
  var $raiz;
  var $elementos;
  var $debajode;
  var $arribade;
  var $listo;
  var $pares;
  function orden($lista=array())
	{
		$this->raiz=$lista;
		$this->elementos=$lista;
		$this->debajode=array();
		$this->arribade=array();
		$this->listo=false;
		$this->pares=array();
		foreach($lista as $e)
			{
				$this->debajode[$e]=null;
				$this->arribade[$e]=null;
			}
	}
  function lt($menor,$mayor)
	{ //funcin que agrega o mueve a $menor debajo de $mayor (si es que no lo est)
		if($this->listo)
			{
				//print "$menor < $mayor \n";
				if(in_array($menor,$this->elementos))
					{ //si menor ya est en este orden debemos ver si ya est debajo o no.
						//print "$menor ya existe\n";
						$comp=$this->comparables($menor,$mayor);
						if($comp==0) //si no son comparables
							{ //entonces hay que encontrar al menor elemento mayor que ambos
								$r1=$this->rutade($menor);
								$r2=$this->rutade($mayor);
								$mpc=0; //menor padre comn
								while($r1[0] == $r2[0])
									{
										$mpc=array_shift($r1);
										array_shift($r2);
									}
								//print "\t$mpc [ $ir ],$r1[0],$menor<$mayor\n";
								if(!$mpc) //si es la rama completa
									{ //borramos su raiz
										$ir=array_search($r1[0],$this->raiz);
										if($ir !== false)
											unset($this->raiz[$ir]);
									}
								else
									{ //pero si no tenemos que quitar a $r1[0] de los inmediatamente menores de $mpc
										$ir=array_search($r1[0],$this->arribade[$mpc]);
										//print "\t$mpc [ $ir ],$r1[0],$menor<$mayor\n";
										if($ir !== false)
											unset($this->arribade[$mpc][$ir]);
									}
								$this->debajode[$r1[0]]=$mayor;
								if(!$this->arribade[$mayor])
									$this->arribade[$mayor]=array();
								$this->arribade[$mayor][]=$r1[0];
							}
							
						//if($comp>0 ) //tenemos un problema pues $menor es mayo que $mayor
						//if($comp<0) //ya estn en el orden correcto
					}
				else
					{ //pero si menor no est en el orden simplemente lo agregamos.
						//print "$menor es nuevo\n";
						$this->elementos[]=$menor;
						$this->debajode[$menor]=$mayor;
						if(!$this->arribade[$mayor])
							$this->arribade[$mayor]=array();
						$this->arribade[$mayor][]=$menor;
						$this->arribade[$menor]=null;
					}
			}
		else
			{
				$this->pares[]=array($menor,$mayor);
			}
	}
  function comparables($a,$b) //funcin que determina si $a y $b son comparables
	{ //si no son comparables devuelve 0, pero si lo son -1 significa que $a<$b y 1 que $a>$b
		$ra=$this->rutade($a);
		$rb=$this->rutade($b);
		if(in_array($a,$rb))
			return 1;
		if(in_array($b,$ra))
			return -1;
		return 0;
	}
  function rutade($e)
	{ //devuelve la ruta que contiene a $e
		$ruta=array($e);
		$k=$e;
		while($this->debajode[$k] !== null)
			{
				$k=$this->debajode[$k];
				array_unshift($ruta,$k);
			}
		return $ruta;
	}
  function ordenados($nodo=null)
	{
		$lista=array();
		if($nodo)
			{
				foreach($this->arribade[$nodo] as $n)
					{
						array_unshift($lista,$n);
						if(is_array($this->arribade[$n]))
							$lista=array_merge($this->ordenados($n),$lista);
					}
			}
		else
			{
				$this->prepara();
				foreach($this->raiz as $n)
					{
						array_unshift($lista,$n);
						if(is_array($this->arribade[$n]))
							$lista=array_merge($this->ordenados($n),$lista);
					}
			}
		return $lista;
	}
  function add($e) //agrega un nuevo elemento si no existe
	{
		if(!in_array($e,$this->elementos))
			{
				$this->elementos[]=$e;
				$this->raiz[]=$e;
				$this->arribade[$e]=null;
				$this->debajode[$e]=null;
			}
	}
  function prepara() //reacomoda las asignaciones para que queden bien
	{
		$this->listo=true;
		$pares=$this->pares;
		$izq=array();
		$igi=array();
		$der=array();
		$igd=array();
		foreach($pares as $k=>$p)
			{ //checamos que hay a la izquierda y a la derecha y guardamos sus indices en $pares
				if(!in_array($p[0],$izq))
					$izq[]=$p[0];
				$igi[$p[0]][]=$k;
				if(!in_array($p[1],$der))
					$der[]=$p[1];
				$igd[$p[1]][]=$k;
			}
		foreach($der as $k=>$d)
			{ //para cada derecho que no est en los izquierdos
				if(!in_array($d,$izq))
					{
						foreach($igd[$d] as $kp)
							{ //aplicamos la desigualdad
								if(isset($pares[$kp]))
									{
										$this->lt($pares[$kp][0],$pares[$kp][1]);
										unset($pares[$kp]); //y lo borramos de la lista de pares.
									}
							}
						unset($igd[$d]);
						unset($der[$k]);
					}
			}
		//ahora vamos a reacomodar todo de acuerdo a grupos izquierdos
		$pares2=array();
		foreach($izq as $i)
			{ //para cada izquierdo
				foreach($igi[$i] as $kp)
					{ //recorremos su grupo
						if(isset($pares[$kp]))
							$pares2[]=$pares[$kp];
					}
			}
		$pares=$pares2;
		//revisamos nuevamente la lista de pares
		$izq=array();
		$igi=array();
		$der=array();
		$igd=array();
		$izqfinal=array();
		foreach($pares as $k=>$p)
			{
				if(!in_array($p[0],$izq))
					$izq[]=$p[0];
				$igi[$p[0]][]=$k;
				if(!in_array($p[1],$der))
					$der[]=$p[1];
				$igd[$p[1]][]=$k;
			}
		//Ahora reordenamos la lista de izquierdos
		$nextidx=count($izq);
		for($idx=0;$idx < $nextidx;$idx++)
			{
				$i=$izq[$idx];
				unset($izq[$idx]);
				$mover=false;
				foreach($igi[$i] as $kp)
					{
						$d=$pares[$kp][1];
						if(in_array($d,$izq))
							$mover=true;
					}
				if($mover)
					{
						$izq[$nextidx]=$i;
						$nextidx++;
					}
				else
					$izqfinal[]=$i;
			}
		foreach($izqfinal as $i)
			{
				foreach($igi[$i] as $kp)
					$this->lt($pares[$kp][0],$pares[$kp][1]);
			}
		$this->pares=$pares;
	}
}

?>